Attribute VB_Name = "basPropLoad"
Option Explicit

Dim parent As Form
Global frmDbugInfoLoaded As Boolean

Const MARK_DONE& = &H8000000  ' This loc has aleady been processed
Const MARK_SPIN& = &H4000000  ' This is a Spin instruction
Const MARK_ASMB& = &H2000000  ' This is an Asmb instruction
Const MARK_ORG0& = &H1000000  ' Loc is first entry in an Asmb block ( ie ORG 0 )

Const MARK_ADAT& = &H100000   ' Used by ASMB for Data

Const MARK_ARAY& = &H80000    ' Part of an Array Var
Const MARK_ARET& = &H40000    ' Asmb RET instruction
Const MARK_XFUN& = &H20000    ' Function
Const MARK_XOBJ& = &H10000    ' Object Links

Const MARK_PADS& = &H8000&    ' Used for padding / alignment
Const MARK_CALL& = &H4000&
Const MARK_GOTO& = &H3000&    ' Yes, 3
Const MARK_JMPT& = &H2000&
Const MARK_JMPF& = &H1000&

Const MARK_JMPS& = MARK_CALL Or MARK_GOTO Or MARK_JMPT Or MARK_JMPF

Const MARK_LINK& = &H800&     ' Loc is referenced as a link variable
Const MARK_LONG& = &H400&     ' Loc is referenced as a long variable
Const MARK_WORD& = &H200&     ' Loc is referenced as a word variable
Const MARK_BYTE& = &H100&     ' Loc is referenced as a byte variable

Const MARK_VARS& = MARK_BYTE Or MARK_WORD Or MARK_LONG Or MARK_LINK

Const VARTYPE_MEM& = 0
Const VARTYPE_OBJ& = 1
Const VARTYPE_VAR& = 2
Const VARTYPE_LOC& = 3

Const MODE_NULL& = 0
Const MODE_INIT& = 1
Const MODE_INFO& = 2
Const MODE_LINK& = 3
Const MODE_SPIN& = 4
Const MODE_ASMB& = 5
Const MODE_ADAT& = 6
Const MODE_DATA& = 7
Const MODE_VARS& = 8
Const MODE_STAK& = 9
Const MODE_PADS& = 10

Const LABEL_TYPE_SPIN& = 0
Const LABEL_TYPE_ASMB& = 1
Const LABEL_TYPE_LINK& = 2
Const LABEL_TYPE_CALL& = 3

Const EEPROM_SIZE& = &H8000&
Const MAX_EEPROM& = EEPROM_SIZE& - 1

Dim eeprom&(MAX_EEPROM&)
Dim labels&(MAX_EEPROM&)
Dim callPair&(MAX_EEPROM&)
Dim callFrom&(MAX_EEPROM&)
Dim varsUsed&(MAX_EEPROM&)
Dim stack&(MAX_EEPROM&)

Dim opc_nam$(&HFF)
Dim opc_arg$(&HFF)
Dim eff_nam$(&HFF)
Dim reg_nam$(&H1F)

Dim asm_nam$(&H3F)
Dim asm_wbit(&H3F) As Boolean
Dim ifs_nam$(&HF)

Dim doneOpc(&HFF) As Boolean
Dim doneEff(&HFF) As Boolean

Dim orgTxt$
Dim eepTxt$
Dim labTxt$
Dim opcTxt$
Dim oprTxt$

Const HOLD_MAX& = 10

Dim orgHeld$(HOLD_MAX)
Dim eepHeld$(HOLD_MAX)
Dim labHeld$(HOLD_MAX)
Dim opcHeld$(HOLD_MAX)
Dim oprHeld$(HOLD_MAX)
Dim held&

Dim pc&
Dim org&
Dim opc&
Dim opr&

Dim asmDst&
Dim asmSrc&

Dim lastPc&
Dim labelTypeList$
Dim frameIsForFunction As Boolean
Dim frameCount&
Dim stackLabelNumber&
Dim asmbLabelNumber&
Dim priCount&
Dim pubCount&
Global sourcecodeFile$
Dim useSourcecodeFile$
Global sourcecodeWarnIfMissing As Boolean

Dim mode&

Global lastFile$
Global saveFile$

Dim hadCrLf As Boolean
Dim indent&

' From initialisation vectors

Dim pBase&
Dim vMain&
Dim sBase&
Dim pInit&
Dim sInit&
Dim vEnds&

' Runtime versions of above

Dim oBase& ' := pBase&
Dim vBase& ' := vMain&

Dim flgIncludeSourceCode As Boolean
Dim flgShowImage         As Boolean
Dim flgProcessAssembler  As Boolean
Dim flgShowLabels        As Boolean
Dim flgFoldOpcodes       As Boolean
Dim flgFoldEffects       As Boolean
Dim flgFoldOperators     As Boolean
Dim flgFoldArguments     As Boolean
Dim flgFoldSpr           As Boolean
Dim flgFoldIndexes       As Boolean
Dim flgCastVariables     As Boolean
Dim flgSymbolTable       As Boolean
Dim flgColonsAfterlabels As Boolean
Dim flgForceHash         As Boolean
Dim flgNoDefaultLong     As Boolean

Dim flgDebug             As Boolean
Dim flgDebugSpin         As Boolean
Dim flgDebugAsmb         As Boolean
Dim flgDebugVars         As Boolean

Global displayIsAssembly As Boolean

Dim createListing As Boolean
Dim asmbMarker&
Dim isJump As Boolean
Dim asmbNeedToFinalise As Boolean
Dim pushMarker&(3)

Dim debugText$
Dim debugLaterText$
Dim reportMissingFunctionality As Boolean
Dim abort As Boolean

Const PAD_EEPROM& = 13
Const PAD_LABEL& = 29
Const PAD_OPC& = 38
Const PAD_OPR& = 9
Const PAD_COMMENT& = 24

Private Declare _
  Function LockWindowUpdate _
  Lib "user32" _
  ( _
    ByVal hwndLock As Long _
  ) As Long

Sub Asmb_Finalise()
Dim labPush$
Dim asmbPc&
Dim spinPc&
Dim lastOrg&

  If asmbNeedToFinalise Then
    labPush$ = labTxt$

    ' We ignore everything in stack&() which has already been shown in the
    ' Asmb_Decode processing. We need to find if there's anything else to
    ' show and if so, show it.

    lastOrg& = -1
    For asmbPc& = 0 To &H1EF
      spinPc& = org& + (asmbPc& * 4)
      If spinPc& >= pc& Then
        If stack&(spinPc&) <> 0 Then
          If lastOrg& <> asmbPc& Then
            orgTxt$ = "_"
            labTxt$ = ""
            eepTxt$ = ""
            opcTxt$ = "ALIGN"
            If asmbPc& > &HFF Then
              oprTxt$ = "       ORG      $" + FNhex$(asmbPc&, 3) + "_"
            Else
              oprTxt$ = "       ORG      $" + FNhex$(asmbPc&, 2) + "_"
            End If
            Call DisAsm_Print
          End If
          lastOrg& = asmbPc& + 1
          orgTxt$ = "       " + FNhex$(asmbPc&, 3)
          labTxt$ = "V" + FNstr$(stack&(spinPc&) And &HFFFF&)
          If flgColonsAfterlabels Then
            labTxt$ = labTxt$ + ":"
          End If
          eepTxt$ = "00 00 00 00"
          opcTxt$ = "                LONG"
          oprTxt$ = "    0"
          If PeekLong&(spinPc&) <> 0 Then
            oprTxt$ = oprTxt$ + "         ; $"
            oprTxt$ = oprTxt$ + FNhex$(PeekByte&(spinPc& + 0), 2)
            oprTxt$ = oprTxt$ + FNhex$(PeekByte&(spinPc& + 1), 2)
            oprTxt$ = oprTxt$ + FNhex$(PeekByte&(spinPc& + 2), 2)
            oprTxt$ = oprTxt$ + FNhex$(PeekByte&(spinPc& + 3), 2)
            oprTxt$ = oprTxt$ + " / " + FNstr$(PeekLong&(spinPc&))
          End If
          Call DisAsm_Print
        End If
      End If
    Next

    asmbNeedToFinalise = False
    Erase stack&()

    labTxt$ = labPush$
  End If
End Sub
Sub Asmb_Finalise_Init()

  asmbNeedToFinalise = True
  Erase stack&()

End Sub


Sub Asmb_Finalise_Mark(ByVal offset&)
  offset& = org& + (offset& * 4)
  If stack&(offset&) = 0 Then
    asmbLabelNumber& = asmbLabelNumber& + 1
    stack&(offset&) = asmbLabelNumber&
    If InStr(labelTypeList$, "V") = 0 Then
      labelTypeList$ = labelTypeList$ + "V"
    End If
  End If
End Sub

Function Asmb_IsAsmbData(ByVal pc&) As Boolean

  If (eeprom&(pc&) And MARK_ADAT) = 0 Then
    Asmb_IsAsmbData = False
  Else
    If stack&(pc&) <> 0 Then
      Asmb_IsAsmbData = True
    Else
      Asmb_IsAsmbData = ((eeprom&(pc& + 0) Or eeprom&(pc& + 1) Or eeprom&(pc& + 2) Or eeprom&(pc& + 3)) And &HFF) = 0
    End If
  End If
End Function

Sub Debug_DoneLoad()
Dim i&
  If RunningInIde Then
    If GetSetting(appId$, "Debug Opc", "Flag", "") = "" Then
      For i& = 0 To &HFF
        doneOpc(i&) = False
        doneEff(i&) = False
      Next
    Else
      For i& = 0 To &HFF
        doneOpc(i&) = GetSetting(appId$, "Debug Opc", FNhex$(i&, 2), "") = ""
        doneEff(i&) = GetSetting(appId$, "Debug Eff", FNhex$(i&, 2), "") = ""
      Next
    End If
  Else
    For i& = 0 To &HFF
      doneOpc(i&) = True
      doneEff(i&) = True
    Next
  End If
End Sub

Sub Debug_DoneSave()
Dim i&
  If RunningInIde Then
    SaveSetting appId$, "Debug Opc", "Flag", IsoDateAndTime$
    For i& = 0 To &HFF
      If doneOpc(i&) Then
        SaveSetting appId$, "Debug Opc", FNhex$(i&, 2), ""
      Else
        SaveSetting appId$, "Debug Opc", FNhex$(i&, 2), opc_nam$(i&) + " " + opc_arg$(i&)
      End If
      If doneEff(i&) Then
        SaveSetting appId$, "Debug Eff", FNhex$(i&, 2), ""
      Else
        SaveSetting appId$, "Debug Eff", FNhex$(i&, 2), eff_nam$(i&)
      End If
    Next
  End If
End Sub


Sub Debug_PrintCrLf(Optional ByVal t$)
  If Not frmDbugInfoLoaded Then
    frmDbugInfo.Show
    frmDbugInfo.txtDisplay = ""
    DoEvents
    LockWindowUpdate frmDbugInfo.txtDisplay.hWnd
  End If
  With frmDbugInfo.txtDisplay
    .SelStart = Len(.Text)
    If debugLaterText$ <> "" Then
      .SelText = debugText$ + t$ + vbCrLf + debugLaterText$
    Else
      .SelText = debugText$ + t$ + vbCrLf
    End If
  End With
  debugText$ = ""
  debugLaterText$ = ""
End Sub
Sub Debug_PrintLater(ByVal t$)
  debugLaterText$ = debugLaterText$ + t$ + vbCrLf
End Sub
Sub Debug_Print(ByVal t$)
  debugText$ = debugText$ + t$
End Sub



Sub DisAsm_DumpObjectDesc(ByVal label$)
Dim count&
Dim where&
  pc& = PeekLink&(0)
  If pc& > &H7FFF& Then
    oBase& = vMain&
    Exit Sub
  End If
  where& = oBase&
  If PeekLink&(0) = vMain& Then
    Print #2, FNhex$(where&, 4) + "   " + FNpad$(label$, 9) + FNhex$(PeekLink&(0), 4) + "   VBASE"
  Else
    Print #2, FNhex$(where&, 4) + "   " + FNpad$(label$, 9) + FNhex$(PeekLink&(0), 4) + "   " + Label_Named$(LABEL_TYPE_SPIN, PeekLink&(0))
  End If
  where& = where& + 4
  count& = 0
  While (eeprom&(where&) And MARK_LINK&)
    count& = count& + 1
    Print #2, FNhex$(where&, 4) + "   " + FNpad$(FNsigned$(count&), 9) + FNhex$(PeekLink&(count&), 4) + "   " + Label_Named$(LABEL_TYPE_SPIN, PeekLink&(count&))
    where& = where& + 4
  Wend
  Print #2, ""
  If oBase& = PeekLink&(0) Then
    oBase& = vMain&
  Else
    oBase& = PeekLink&(0)
  End If
End Sub

Sub DisAsm_DumpObjectList()
Dim count&

  Print #2, ""
  Print #2, "Object List"
  Print #2, "==========="
  Print #2, ""

  oBase& = pBase&
  count& = -1
  While oBase& <> vMain&
    If oBase& > &H7FFF& Then
      oBase& = vMain&
    Else
      count& = count& + 1
      If oBase& = PeekLink&(0) Then
        oBase& = vMain&
      Else
        oBase& = PeekLink&(0)
      End If
    End If
  Wend

  Print #2, FNplural$(count&, "object") + " used"
  Print #2, ""

  oBase& = pBase&
  vBase& = vMain&
  Call DisAsm_DumpObjectDesc("PBASE")
  While oBase& <= &H7FFF& And oBase& <> vMain&
    Call DisAsm_DumpObjectDesc(Label_Named$(LABEL_TYPE_SPIN, pc&))
  Wend

  oBase& = pBase&
  vBase& = vMain&

End Sub
Sub Data_Decode_Equs(ByVal pc&, ByVal offset&, ByVal Mark&, ByVal c$, ByVal offsetList$)
Dim i&
Dim anyEqu As Boolean
  If (eeprom&(pc& - offset&) And MARK_PADS) = 0 Then
    anyEqu = False
    For i& = 0 To offset& - 1
      If (eeprom&(pc& - offset& + i&) And Mark&) <> 0 Then
        If Not anyEqu Then
          Call Disasm_ForceBlankLine
          anyEqu = True
        End If
        Call Data_Describe_Equ(pc& - offset&, i&, c$, Mid$(offsetList$, i& + 1, 1))
      End If
    Next
    If anyEqu Then
      Call Disasm_ForceBlankLine
    End If
  End If
End Sub

Sub DisAsm_FixAlignments()

  oBase& = pBase&
  
  While oBase& <> vMain&
    If oBase& > &H7FFF& Then
      oBase& = vMain&
    Else
      Call DisAsm_Align(oBase&)
      If oBase& = PeekLink&(0) Then
        oBase& = vMain&
      Else
        oBase& = PeekLink&(0)
      End If
    End If
  Wend
  
  Call DisAsm_Align(vMain&)
  Call DisAsm_Align(vEnds&)
  
End Sub

Sub DisAsm_FixSpinConstants()
Dim pc&
Dim i&
  For pc& = pInit& To vMain& - 1
    If (eeprom&(pc&) And MARK_BYTE) <> 0 Then
      If (eeprom&(pc& - 1) And MARK_SPIN) <> 0 Then
        Call Mark(pc&, MARK_DONE& Or MARK_BYTE Or MARK_ARAY)
        i& = pc& + 1
        While i& < vMain&
          If (eeprom&(i&) And (MARK_DONE Or MARK_VARS)) = 0 Then
            Call Mark(i&, MARK_BYTE Or MARK_ARAY)
            i& = i& + 1
          Else
            i& = vMain&
          End If
        Wend
      End If
    End If
  Next
End Sub

Sub DisAsm_FixVariables()
Dim pc&

  pc& = vMain&
  While pc& < vEnds

    If (eeprom&(pc&) And MARK_LONG) <> 0 Then
      pc& = pc& + 4
    Else
      If (pc& And 3) = 0 And _
         (eeprom&(pc& + 0) And MARK_VARS) = 0 And _
         (eeprom&(pc& + 1) And MARK_VARS) = 0 And _
         (eeprom&(pc& + 2) And MARK_VARS) = 0 And _
         (eeprom&(pc& + 3) And MARK_VARS) = 0 _
      Then
        eeprom&(pc&) = eeprom(pc&) Or MARK_LONG Or MARK_ARAY
        pc& = pc& + 4
      Else

        If (eeprom&(pc&) And MARK_WORD) <> 0 Then
          pc& = pc& + 2
        Else
          If (pc& And 1) = 0 And _
             (eeprom&(pc& + 0) And MARK_VARS) = 0 And _
             (eeprom&(pc& + 1) And MARK_VARS) = 0 _
          Then
            eeprom&(pc&) = eeprom(pc&) Or MARK_WORD Or MARK_ARAY
            pc& = pc& + 2
          Else

            If (eeprom&(pc&) And MARK_VARS) = 0 Then
              eeprom&(pc&) = eeprom(pc&) Or MARK_WORD Or MARK_ARAY
            End If
            pc& = pc& + 1

          End If
        End If
      End If
    End If
  Wend

End Sub

Sub Disasm_ForceBlankLine()
Dim orgpush$
Dim eepPush$
Dim labPush$

  orgpush$ = orgTxt$
  eepPush$ = eepTxt$
  labPush$ = labTxt$

  orgTxt$ = ""
  eepTxt$ = ""
  labTxt$ = ""
  opcTxt$ = "_"
  oprTxt$ = ""
  Call DisAsm_Print

  orgTxt$ = orgpush$
  eepTxt$ = eepPush$
  labTxt$ = labPush$

End Sub
Sub DisAsm_Generate(ByVal filename$, ByVal listfile$, ByVal autoReloaded As Boolean)
Dim labTmp$

  displayIsAssembly = Not flgShowImage

  Open listfile$ For Output As #2

  Print #2, ""

  If flgShowImage Then

    Print #2, "Disassembly of " + filename$
    Print #2, String$(Len(filename$) + 15, "=")

    If autoReloaded Then
      Print #2, ""
      Print #2, "Auto-Reloaded at " + Time$
    End If

     If Version_KnownBug$("") <> "" Then
      Print #2, Version_KnownBug$("")
    End If
    Print #2, ""
    Print #2, "Addr   Org   Instruction     Label    Opcode   Operand"
    Print #2, "----   ---   -----------     -----    ------   -------"
    Print #2, ""
  End If

  hadCrLf = True
  indent& = 0

  ' Find last used pc

  lastPc& = MAX_EEPROM&
  While (eeprom&(lastPc&) And MARK_DONE) = 0
    lastPc& = lastPc& - 1
  Wend

  frmPropLoad.StatusBar.Panels(2).Text = " $0000 - $" + FNhex$(vEnds& - 1, 4) + " = " + FNstr$(vEnds&) + " / " + FNpercent$(vEnds&, EEPROM_SIZE&) + "% "

  If pBase& > lastPc& Then lastPc& = pBase&
  If vMain& > lastPc& Then lastPc& = vMain&
  If sBase& > lastPc& Then lastPc& = sBase&
  If pInit& > lastPc& Then lastPc& = pInit&
  If sInit& - 1 > lastPc& Then lastPc& = sInit& - 1
  If lastPc& > MAX_EEPROM& Then
    lastPc& = MAX_EEPROM&
  End If
  If vEnds& < vMain& Then
    vEnds& = vMain&
  End If
  
  Call DisAsm_FixSpinConstants
  Call DisAsm_FixVariables
  Call DisAsm_FixAlignments
  Call Disasm_SetLabels

  createListing = True
  pc& = 0
  org& = 0
  asmbMarker& = 0
  frameIsForFunction = False
  frameCount& = 0
  pubCount& = 0
  priCount& = 0
  asmbNeedToFinalise = False

  Call DisAsm_Mode(MODE_INIT&)
  While pc& <= lastPc&
    If labels&(pc&) <> 0 Then
      labTxt$ = Label_Named$(LABEL_TYPE_SPIN, pc&)
      If flgColonsAfterlabels Then
        labTxt$ = labTxt$ + ":"
      End If
    Else
      labTxt$ = ""
    End If
    Select Case mode&
      Case MODE_INIT
        Call DisAsm_Info("LONG     k4", "Clock Freq")
        Call DisAsm_Info("BYTE     y", "Clock Mode_")
        Call DisAsm_Info("BYTE     $k1", "Checksum_")
        Call DisAsm_Info("WORD     $k2", "PBASE - Base of Program")
        Call DisAsm_Info("WORD     $k2", "VBASE - Base of Variables")
        Call DisAsm_Info("WORD     $k2", "SBASE - Base of Stack")
        Call DisAsm_Info("WORD     $k2", "PINIT - Initial Program Counter")
        Call DisAsm_Info("WORD     $k2", "SINIT - Initial Stack Pointer_")
        Call DisAsm_Mode(MODE_INFO)
      Case MODE_INFO
        oBase& = pBase&
        vBase& = vMain&
        Call DisAsm_Info("LINK     x", "+0 - First Object_")
        Call DisAsm_Mode(MODE_NULL)
      Case MODE_STAK
        Call DisAsm_Info("LONG     ks")
      Case Else
        If (eeprom&(pc&) And MARK_SPIN) <> 0 Then
          Call Asmb_Finalise
          If (eeprom&(pc&) And MARK_CALL&) <> 0 Then
            indent& = 0
            If flgIncludeSourceCode Then
              Call SourceCode_Include
            End If
            Call Spin_GenerateStackVars(pc&)
          End If
          Call DisAsm_Mode(MODE_SPIN)
          Call Spin_Decode(pc&)
          Call DisAsm_Print
        Else
          If (eeprom&(pc&) And MARK_ASMB) <> 0 And (eeprom&(pc&) And MARK_LINK) = 0 Then
            If Len(labTxt$) = 0 Then
              If stack&(pc&) <> 0 Then
                labTxt$ = "V" + FNstr$(stack&(pc&) And &HFFFF&)
                If flgColonsAfterlabels Then
                  labTxt$ = labTxt$ + ":"
                End If
              End If
            End If
            If (eeprom&(pc&) And MARK_ORG0) <> 0 Then
              Call Asmb_Finalise
              Call Asmb_Finalise_Init
              labTmp$ = labTxt$
              orgTxt$ = "_"
              eepTxt$ = ""
              labTxt$ = ""
              opcTxt$ = "ALIGN"
              oprTxt$ = "       ORG      0_"
              Call DisAsm_Print
              labTxt$ = labTmp$
            End If
            Call Asmb_Decode(pc&)
            Call DisAsm_Print
          Else
            If (eeprom&(pc&) And MARK_VARS) <> 0 Then
              If (eeprom&(pc&) And MARK_XOBJ) <> 0 Then
                oBase& = pc&
                Call DisAsm_InsertLabel("", "ALIGN", "OBJECT")
              End If
              Call Data_Decode
            Else
              Call DisAsm_Mode(MODE_NULL)
              If flgShowImage Then
                If labTxt$ <> "" Then
                  orgTxt$ = FNhex$(pc&, 4)
                  eepTxt$ = ""
                  opcTxt$ = ""
                  oprTxt$ = ""
                  Call DisAsm_Print
                End If
                labTxt$ = "; ----"
              End If
              Call Spin_Decode(pc&)
              Call DisAsm_Print
            End If
          End If
        End If
    End Select
    If pc& = vMain& Then Call DisAsm_InsertLabel("VBASE", "ALIGN", "LONG"): Call DisAsm_Mode(MODE_VARS)
    If pc& = vEnds& Then Call DisAsm_InsertLabel("VENDS", "ALIGN", "LONG"): Call DisAsm_Mode(MODE_STAK)
    If pc& = sBase& Then Call DisAsm_InsertLabel("SBASE"): Call DisAsm_Mode(MODE_STAK)
    If pc& = sInit& Then Call DisAsm_InsertLabel("SINIT"): Call DisAsm_Mode(MODE_STAK)
    If pc& = pBase& Then Call DisAsm_InsertLabel("PBASE", "ALIGN", "OBJECT"): Call DisAsm_Mode(MODE_INFO)
    If pc& = pInit& Then Call DisAsm_InsertLabel("PINIT", "ALIGN", "SPIN"): Call DisAsm_Mode(MODE_SPIN)
  Wend

  Call PeepHole_Flush

  If flgShowImage Then

    If flgSymbolTable Then
      Call DisAsm_DumpSymbolTable
      Call DisAsm_DumpObjectList
    End If

  Else

    Print #2, ""
    Print #2, "      END"

  End If

  Close #2

End Sub
Sub Failed(ByVal t$)
  If reportMissingFunctionality Then
    Select Case MsgBox(t$ + vbCrLf + vbCrLf + "Continue reporting problem issues?", vbCritical + vbYesNoCancel, App.FileDescription)
      Case vbYes
      Case vbNo
        reportMissingFunctionality = False
      Case vbCancel
        reportMissingFunctionality = False
        abort = True
      End Select
  End If
End Sub

Sub Mark(ByVal pc&, ByVal m&)
  eeprom&(pc&) = eeprom&(pc&) Or m&
End Sub

Function PeekWord&(ByVal pc&)
Dim w&
  w& = PeekByte&(pc& + 0)
  w& = w& Or (PeekByte&(pc& + 1) * 256)
  PeekWord& = w&
End Function
Function PeekLong&(ByVal pc&)
Dim l&
  l& = PeekWord&(pc& + 0)
  l& = l& Or FNshl&(PeekWord&(pc& + 2), 16)
  PeekLong& = l&
End Function
Sub PeepHole_foldArguments(Optional ByVal maxArgs&)
Dim i&
Dim c$

  If flgFoldArguments Then

    If opcHeld$(held& - 1) = "PUSH" Then

      If Len(oprTxt$) <> 0 Then
        oprTxt$ = oprTxt$ + " ( "
        c$ = " )"
      Else
        c$ = ""
      End If

      i& = Len(oprTxt$)
      oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + c$ + Right$(oprTxt$, Len(oprTxt$) - i&)
      Call PeepHole_Fold(opcTxt$, oprTxt$)

      While opcHeld$(held& - 1) = "PUSH" And maxArgs& <> 1
        oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + ", " + Right$(oprTxt$, Len(oprTxt$) - i&)
        Call PeepHole_Fold(opcTxt$, oprTxt$)
        maxArgs& = maxArgs& - 1
      Wend

    End If

  End If

End Sub

Function PurifyText$(ByVal t$)
Dim o$
Dim i&
Dim c$
  o$ = ""
  For i& = 1 To Len(t$)
    c$ = Mid$(t$, i&, 1)
    If Asc(c$) < &H20 Or Asc(c$) > &H7E Then
      o$ = o$ + " "
    Else
      o$ = o$ + c$
    End If
  Next
  PurifyText$ = o$
End Function

Sub SourceCode_Init()
  useSourcecodeFile$ = sourcecodeFile$
  If flgIncludeSourceCode Then
    If FNexists(sourcecodeFile$) Then
      sourcecodeWarnIfMissing = True
      If Not RunningInIde Then
        If PropellerToolIsOpen Then
  If Not frmPropLoad.mnuFile_InhibitWarnings.Checked Then
          MsgBox "The Propller Tool is being used." + vbCrLf + vbCrLf + "Please ensure you have saved the source file within the Propeller Tool if it is being edited or the included source code may not be the same as the Spin program being decompiled.", vbExclamation, App.FileDescription
  End If
        End If
      End If
    Else
      flgIncludeSourceCode = False
      If sourcecodeWarnIfMissing Then
        sourcecodeWarnIfMissing = False
  If Not frmPropLoad.mnuFile_InhibitWarnings.Checked Then
        MsgBox "Cannot find source file" + vbCrLf + vbCrLf + sourcecodeFile$, vbInformation, App.FileDescription
  End If
      End If
    End If
  End If
End Sub

Sub SourceCode_Include()
Dim labPush$

  labPush$ = labTxt$

  orgTxt$ = "===="
  eepTxt$ = ""
  labTxt$ = ""
  oprTxt$ = ""

  If pubCount& >= 0 Then
    pubCount& = pubCount& + 1
    If Not SourceCode_Included("PUB", pubCount&) Then
      pubCount& = -1
      priCount& = 1
      If Not SourceCode_Included("PRI", priCount&) Then
        priCount& = -1
      End If
    End If
  Else
    If priCount& >= 0 Then
      priCount& = priCount& + 1
      If Not SourceCode_Included("PRI", priCount&) Then
        priCount& = -1
      End If
    End If
  End If

  labTxt$ = labPush$

End Sub
Function FNliteral$(ByVal v&, Optional ByVal isAsmbLiteral As Boolean)
Dim n$
Dim msbMask&
Dim lsbMask&
Dim bitMask&
  If isAsmbLiteral Then
    If v& > &HFF Then
      n$ = "$" + FNhex$(v&, 3)
    Else
      n$ = "$" + FNhex$(v&, 2)
    End If
  Else
    If (v& And &HFFFFFFF0) = 0 Then
      n$ = FNstr$(v&)
    Else
      msbMask& = &H80000000
      While (v& And msbMask&) = 0
        msbMask& = FNshr&(msbMask&, 1) Or &H80000000
      Wend
      lsbMask& = 1
      While (v& And lsbMask&) = 0
        lsbMask& = FNshl&(lsbMask&, 1) Or 1
      Wend
      bitMask& = Not (FNshl&(msbMask&, 1) Or FNshr&(lsbMask&, 1))
      If v& = bitMask& Then
        n$ = "$" + FNhex$(v&, ((Len(Hex$(v&)) + 1) \ 2) * 2)
      Else
'        If (v& And &HFFFF8000) = 0 Then
'          If (eeprom&(v&) And MARK_VARS) <> 0 Then
'            n$ = "$" + FNhex$(v&, ((Len(Hex$(v&)) + 1) \ 2) * 2) + " OOPS"
'          Else
'            n$ = FNstr$(v&)
'          End If
'        Else
          n$ = FNstr$(v&)
'        End If
      End If
    End If
  End If
  FNliteral$ = n$
End Function

Function FNpercent$(ByVal n&, ByVal total&)
  FNpercent$ = FNstr$(Int((n& / total&) * 100 + 0.5))
End Function

Function FNplural$(ByVal n&, ByVal t$)
  If n& = 0 Then
    FNplural$ = "No " + t$ + "s"
  Else
    If n& = 1 Then
      FNplural$ = FNstr$(n&) + " " + t$
    Else
      FNplural$ = FNstr$(n&) + " " + t$ + "s"
    End If
  End If
End Function

Sub PrintError(ByVal errorNumber&)
  On Error GoTo 0
  MsgBox "Unable to print" + vbCrLf + vbCrLf + "Error :" + Str$(errorNumber&), vbExclamation, App.FileDescription
End Sub

Sub Asmb_Add(ByVal nam$, ByVal arg$)
Dim opc&
Dim i&
  opc& = 0
  For i& = 1 To 6
    opc& = opc& * 2
    If Mid$(arg$, i&, 1) = "1" Then
      opc& = opc& + 1
    End If
  Next
  asm_nam$(opc&) = nam$
  asm_wbit(opc&) = Mid$(nam$, 10, 1) = "1"
End Sub

Function DisAsm_CalculateChecksum&()
Dim hash&
  For pc& = 0 To MAX_EEPROM&
    hash& = (hash& + eeprom&(pc&)) And &HFF
  Next
  DisAsm_CalculateChecksum& = hash&
End Function

Sub DisAsm_ChecksumFix(ByVal pc&, ByVal pokeVal&)
  If pc& >= 0 Then
    If eeprom&(pc&) = 0 Then
      eeprom&(pc&) = pokeVal&
    End If
  End If
End Sub

Sub DisAsm_Traverse()

  reportMissingFunctionality = RunningInIde
  abort = False

  ' Get program pointers

  pc& = &H6
  pBase& = GetWord&
  vMain& = GetWord&
  sBase& = GetWord&
  pInit& = GetWord&
  sInit& = GetWord&

  vEnds& = sBase& - 8
  oBase& = pBase&
  vBase& = vMain&

  Call Mark(pBase&, MARK_DONE Or MARK_LINK)
  Call Mark(pBase& + 4, MARK_DONE Or MARK_LINK)

  Call Mark(vEnds&, MARK_DONE)

  ' This is okay

  Call Mark(pInit&, MARK_CALL)

  ' Traverse the program code

  If flgDebug Then Call Debug_PrintCrLf("Init " + FNhex$(pInit&, 4) + vbCrLf)

  Call Spin_Found(pInit&)

'                Call Asmb_Found_Org0(&H30)

End Sub

Sub Menu_Help_ShowAsmbOpcodes()
Dim i&
Dim o$
 parent.ReloadTimer.Enabled = False
  For i& = 0 To &H3F
    o$ = o$ + vbCrLf + FNhex$(i&, 2) + "    " + FNbin$(i&, 6) + "    " + asm_nam$(i&)
  Next
  parent.txtDisplay.Text$ = "Assembler Opcodes" + vbCrLf + "=================" + vbCrLf + o$
End Sub

Sub Menu_Help_ShowSpinEffects()
Dim i&
Dim o$
Dim t$
  parent.ReloadTimer.Enabled = False
  For i& = 0 To &H7F
    t$ = FNhex$(i&, 2)
    If Left$(eff_nam$(i&), 1) <> "$" Then
      t$ = t$ + "    " + eff_nam$(i&)
    End If
    t$ = FNpad$(t$, 40) + FNhex$(i& Or &H80, 2)
    If Left$(eff_nam$(i& Or &H80), 1) <> "$" Then
      t$ = t$ + "    " + eff_nam$(i& Or &H80)
    End If
    o$ = o$ + vbCrLf + t$
  Next
  parent.txtDisplay.Text$ = "Spin 'Using' Effects" + vbCrLf + "====================" + vbCrLf + vbCrLf + FNpad$("When used with an opcode", 40) + "When used as a unary operator" + vbCrLf + o$
End Sub

Sub Menu_Help_ShowSpinOpodes()
Dim i&
Dim o$
  parent.ReloadTimer.Enabled = False
  For i& = 0 To &HFF
    o$ = o$ + vbCrLf
    If doneOpc(i&) Then
      o$ = o$ + "  "
    Else
      o$ = o$ + "**"
    End If
    o$ = o$ + "  " + FNhex$(i&, 2) + "    " + FNpad$(opc_nam$(i&), PAD_OPR) + opc_arg$(i&)
  Next
   parent.txtDisplay.Text$ = "Spin Opcodes" + vbCrLf + "============" + vbCrLf + o$
End Sub

Sub Menu_Help_ShowImageFlags()
Dim pc&
Dim o$
Dim f$
Dim d&

  parent.MousePointer = 11
  parent.ReloadTimer.Enabled = False
  parent.txtDisplay.Text = ""

  f$ = GetTempFile$
  d& = FreeFile
  Open f$ For Output As #d&
  Print #d&, "Image Flags" + vbCrLf + "============"
  For pc& = 0 To lastPc&
    o$ = vbCrLf + FNhex$(pc&, 4) + "  " + FNhex$(eeprom&(pc&), 8) + " "

    If (eeprom&(pc&) And MARK_DONE&) <> 0 Then o$ = o$ + " Done" Else o$ = o$ + "     "
    If (eeprom&(pc&) And MARK_SPIN&) <> 0 Then o$ = o$ + " Spin"
    If (eeprom&(pc&) And MARK_ASMB&) <> 0 Then o$ = o$ + " Asmb"
    If (eeprom&(pc&) And MARK_ORG0&) <> 0 Then o$ = o$ + " Org0"

    If (eeprom&(pc&) And MARK_ADAT&) <> 0 Then o$ = o$ + " Adat"

    If (eeprom&(pc&) And MARK_ARAY&) <> 0 Then o$ = o$ + " Aray"
    If (eeprom&(pc&) And MARK_ARET&) <> 0 Then o$ = o$ + " Aret"
    If (eeprom&(pc&) And MARK_XFUN&) <> 0 Then o$ = o$ + " Xfun"
    If (eeprom&(pc&) And MARK_XOBJ&) <> 0 Then o$ = o$ + " Xobj"

    If (eeprom&(pc&) And MARK_PADS&) <> 0 Then o$ = o$ + " Pads"
    If (eeprom&(pc&) And MARK_CALL&) <> 0 Then o$ = o$ + " Call"
    If (eeprom&(pc&) And MARK_GOTO&) = MARK_GOTO Then
      o$ = o$ + " Goto"
    Else
      If (eeprom&(pc&) And MARK_JMPT&) <> 0 Then o$ = o$ + " JmpT"
      If (eeprom&(pc&) And MARK_JMPF&) <> 0 Then o$ = o$ + " JmpF"
    End If

    If (eeprom&(pc&) And MARK_LINK&) <> 0 Then o$ = o$ + " Link"
    If (eeprom&(pc&) And MARK_LONG&) <> 0 Then o$ = o$ + " Long"
    If (eeprom&(pc&) And MARK_WORD&) <> 0 Then o$ = o$ + " Word"
    If (eeprom&(pc&) And MARK_BYTE&) <> 0 Then o$ = o$ + " Byte"

    Print #d&, o$;
  Next
  Close #d&
  frmPropLoad.txtDisplay.LoadFile (f$)
  Kill f$
  parent.MousePointer = 0
End Sub

Sub PeepHole_Pop()

  orgTxt$ = orgHeld$(held&)
  eepTxt$ = eepHeld$(held&)
  labTxt$ = labHeld$(held&)
  opcTxt$ = opcHeld$(held&)
  oprTxt$ = oprHeld$(held&)
  held& = held& - 1

End Sub

Sub PeepHole_Push()
Dim i&

  If held& = HOLD_MAX Then
    For i& = 1 To held&
      orgHeld$(i& - 1) = orgHeld$(i&)
      eepHeld$(i& - 1) = eepHeld$(i&)
      labHeld$(i& - 1) = labHeld$(i&)
      opcHeld$(i& - 1) = opcHeld$(i&)
      oprHeld$(i& - 1) = oprHeld$(i&)
    Next
    orgHeld$(held&) = orgTxt$
    eepHeld$(held&) = eepTxt$
    labHeld$(held&) = labTxt$
    opcHeld$(held&) = opcTxt$
    oprHeld$(held&) = oprTxt$
    Call PeepHole_Print(0)
    orgTxt$ = orgHeld$(held&)
    eepTxt$ = eepHeld$(held&)
    labTxt$ = labHeld$(held&)
    opcTxt$ = opcHeld$(held&)
    oprTxt$ = oprHeld$(held&)
  Else
    held& = held& + 1
    orgHeld$(held&) = orgTxt$
    eepHeld$(held&) = eepTxt$
    labHeld$(held&) = labTxt$
    opcHeld$(held&) = opcTxt$
    oprHeld$(held&) = oprTxt$
  End If

End Sub
Sub SetParent(f As Form)
  Set parent = f
End Sub

Sub Spin_GenerateStackVars(ByVal pc&)
Dim i&
Dim count&
Dim varInfo&
Dim varAdr&
Dim stackTop&
Dim labelNumber&
Dim labPush$
Dim subName$

  ' The first thing we need to do is to go through the local sub and find if
  ' there are any variable references which refer to LOC+n.xxxx accesses to
  ' the stack. We count how many there are, and we also fill the stack&()
  ' array with the type of var there is.

  count& = 0
  i& = pc&
  Do
    If varsUsed&(i&) <> 0 Then
      varInfo& = varsUsed&(i&)
      If count& = 0 Then
        Erase stack&()
        stackTop& = -1
      End If
      count& = count& + 1
      varAdr& = varInfo& And &HFFFF&
      stack&(varAdr&) = stack(varAdr&) Or FNshr&(varInfo&, 8)
      If varAdr& > stackTop& Then
        stackTop& = varAdr&
      End If
    End If
    i& = i& + 1
  Loop Until (eeprom&(i&) And MARK_SPIN) = 0 Or (eeprom&(i&) And MARK_CALL) <> 0

  If count& <> 0 Then

    labPush$ = labTxt$
    subName$ = Label_Spin(pc&)

    Call DisAsm_InsertLabel("", "ALIGN", "STACK          ; For " + subName$)

    ' Label all the used variables

    If (stack(0) <> 0) Or (eeprom&(pc&) And MARK_XFUN) <> 0 Then
      stackLabelNumber& = stackLabelNumber& + 1
      stack&(0) = stackLabelNumber&
    End If
    For i& = 4 To stackTop& Step 4
      If stack&(i&) <> 0 Then
        stackLabelNumber& = stackLabelNumber& + 1
        stack&(i&) = stackLabelNumber&
      End If
    Next

    ' List all the used variables

    For i& = 0 To stackTop& Step 4
      orgTxt$ = "      +" + FNhex$(i&, 4)
      eepTxt$ = ""
      labelNumber& = stack&(i&)
      If labelNumber& = 0 Then
        labTxt$ = ""
      Else
        If labelNumber& < 0 Then
          labTxt$ = "RESULT"
        Else
          labTxt$ = "VL" + FNstr$(labelNumber& And &HFFFF&)
        End If
        If flgColonsAfterlabels Then
          labTxt$ = labTxt$ + ":"
        End If
      End If
      opcTxt$ = "LONG"
      oprTxt$ = "0"
      If i& = 0 Then
        oprTxt$ = oprTxt$ + "              ; "
        If (eeprom&(pc&) And MARK_XFUN) <> 0 Then
          oprTxt$ = oprTxt$ + "Result Variable"
        Else
          If labTxt$ = "" Then
            oprTxt$ = oprTxt$ + "Unused Result Variable"
          Else
            oprTxt$ = oprTxt$ + "Unexpected Result Variable Used"
          End If
        End If
      End If
      Call DisAsm_Print
    Next

    Call DisAsm_InsertLabel("", "ALIGN", "SPIN")

    labTxt$ = labPush$

  End If

End Sub

Function Spin_GetVarTyp&(ByVal argTxt$, ByVal i&)
  Select Case Mid$(argTxt$, i& - 5, 3)
    Case "MEM": Spin_GetVarTyp& = VARTYPE_MEM
    Case "OBJ": Spin_GetVarTyp& = VARTYPE_OBJ
    Case "VAR": Spin_GetVarTyp& = VARTYPE_VAR
    Case "LOC": Spin_GetVarTyp& = VARTYPE_LOC
    Case Else:  MsgBox argTxt$
  End Select
End Function

Function SourceCode_Included(ByVal typ$, ByVal count&) As Boolean
Dim done As Boolean
Dim s&
Dim l$

  done = False
  typ$ = UCase$(typ$ + " ")
  s& = FreeFile
  Open useSourcecodeFile$ For Input As #s&
  While Not EOF(s&) And (Not done)
    Line Input #s&, l$
    l$ = RTrim$(l$)
    If UCase$(Left$(LTrim$(l$), 4)) = typ$ Then
      count& = count& - 1
      If count& = 0 Then
        Call Disasm_ForceBlankLine
        opcTxt$ = "; " + l$
        Call DisAsm_Print
        While Not EOF(s&) And (Not done)
          Line Input #s&, l$
          Select Case UCase$(Left$(LTrim$(l$), 4))
            Case "PUB ", "PRI ", "OBJ ", "DAT ", "CON "
              done = True
            Case "{ EN"
              If Left$(l$, 40) = "  { End of Test Wrapper For PropLoad }{ " Then
                l$ = Trim$(Right$(l$, Len(l$) - 40))
                useSourcecodeFile$ = Left$(l$, Len(l$) - 2)
                pubCount& = 0
                priCount& = 0
                done = True
              End If
            Case Else
              l$ = RTrim$(l$)
              Select Case l$
                Case "PUB", "PRI", "OBJ", "DAT", "CON"
                  done = True
                Case Else
                  If Len(l$) <> 0 Then
                    opcTxt$ = "; " + PurifyText$(l$)
                    Call DisAsm_Print
                  End If
              End Select
          End Select
        Wend
        done = True
        Call Disasm_ForceBlankLine
      End If
    End If
  Wend
  Close #s&
  SourceCode_Included = done
End Function




Function Version$()
  Version$ = "Version " + FNstr$(App.Major) + "." + FNnum$(App.Minor, 2) + " #" + FNnum$(App.Revision, 4)
End Function

Sub Asmb_Init()

  Call Asmb_Add("NOP", "------ ---- 0000 --------- ---------")
  Call Asmb_Add("?w?iWRBYTE d,s?iWRBYTE d,#m?w?iRDBYTE d,s?iRDBYTE d,#m", "000000 00?i 1111 ddddddddd sssssssss")    ' **
  Call Asmb_Add("?w?iWRWORD d,s?iWRWORD d,#m?w?iRDWORD d,s?iRDWORD d,#m", "000001 00?i 1111 ddddddddd sssssssss")    ' **
  Call Asmb_Add("?w?iWRLONG d,s?iWRLONG d,#m?w?iRDLONG d,s?iRDLONG d,#m", "000010 00?i 1111 ddddddddd sssssssss")    ' **
  Call Asmb_Add("?iHUBOP d,s?i?0CLKSET d?0?1COGID d?1?2COGINIT d?2?3COGSTOP d?3?4LOCKNEW d?4?5LOCKRET d?5?6LOCKSET d?6?7LOCKCLR d?7HUBOP d,s", "000011 00?? 1111 ddddddddd ssssss???")
  Call Asmb_Add("ROR d,s", "001000 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ROL d,s", "001001 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SHR d,s", "001010 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SHL d,s", "001011 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("RCR d,s", "001100 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("RCL d,s", "001101 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SAR d,s", "001110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("REV d,s", "001111 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MINS d,s", "010000 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MAXS d,s", "010001 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MIN d,s", "010010 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MAX d,s", "010011 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MOVS d,s", "010100 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MOVD d,s", "010101 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MOVI d,s", "010110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("?w?iJMP s*?iJMP #r?w?iJMPRET c,s?i?pCALL e#j?pJMPRET c,#j", "010111 00?? 1111 ddddddddd sssssssss")
  Call Asmb_Add("?wTEST d,s?wAND d,s", "011000 00?i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ANDN d,s", "011001 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("OR d,s", "011010 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("XOR d,s", "011011 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MUXC d,s", "011100 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MUXNC d,s", "011101 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MUXZ d,s", "011110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MUXNZ d,s", "011111 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ADD d,s", "100000 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("?wCMP d,s?wSUB d,s", "100001 00?i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ADDABS d,s", "100010 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUBABS d,s", "100011 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUMC d,s", "100100 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUMNC d,s", "100101 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUMZ d,s", "100110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUMNZ d,s", "100111 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("MOV d,s", "101000 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("NEG d,s", "101001 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ABS d,s", "101010 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ABSNEG d,s", "101011 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("NEGC d,s", "101100 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("NEGNC d,s", "101101 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("NEGZ d,s", "101110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("NEGNZ d,s", "101111 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("CMPS d,s", "110000 000i 1111 ddddddddd sssssssss")
  Call Asmb_Add("CMPSX d,s", "110001 000i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ADDX d,s", "110010 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("?wCMPX d,s?wSUBX d,s", "110011 00?i 1111 ddddddddd sssssssss")    ' *
  Call Asmb_Add("ADDS d,s", "110100 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUBS d,s", "110101 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("ADDSX d,s", "110110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("SUBSX d,s", "110111 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("CMPSUB d,s", "111000 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("?iDJNZ d,s?iDJNZ d,#j", "111001 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("?iTJNZ d,s?iTJNZ d,#j", "111010 000i 1111 ddddddddd sssssssss")
  Call Asmb_Add("?iTJZ d,s?iTJZ d,#j", "111011 000i 1111 ddddddddd sssssssss")
  Call Asmb_Add("WAITPEQ d,s", "111100 000i 1111 ddddddddd sssssssss")
  Call Asmb_Add("WAITPNE d,s", "111101 000i 1111 ddddddddd sssssssss")
  Call Asmb_Add("WAITCNT d,s", "111110 001i 1111 ddddddddd sssssssss")
  Call Asmb_Add("WAITVID d,s", "111111 000i 1111 ddddddddd sssssssss")

  ifs_nam$(0) = "IF_NEVER        "   ' 0000 - Never
  ifs_nam$(1) = "IF_NC_AND_NZ    "   ' 0001
  ifs_nam$(2) = "IF_NC_AND_Z     "   ' 0010
  ifs_nam$(3) = "IF_NC           "   ' 0011
  ifs_nam$(4) = "IF_C_AND_NZ     "   ' 0100
  ifs_nam$(5) = "IF_NZ           "   ' 0101
  ifs_nam$(6) = "IF_C_NE_Z       "   ' 0110
  ifs_nam$(7) = "IF_NC_OR_NZ     "   ' 0111
  ifs_nam$(8) = "IF_C_AND_Z      "   ' 1000
  ifs_nam$(9) = "IF_C_EQ_Z       "   ' 1001
  ifs_nam$(10) = "IF_Z            "  ' 1010
  ifs_nam$(11) = "IF_NC_OR_Z      "  ' 1011
  ifs_nam$(12) = "IF_C            "  ' 1100
  ifs_nam$(13) = "IF_C_OR_NZ      "  ' 1101
  ifs_nam$(14) = "IF_C_OR_Z       "  ' 1110
  ifs_nam$(15) = "                "  ' 1111 - ALWAYS

End Sub
Sub Asmb_Decode(ByVal here&)

Const MASK_O& = &HFC000000   ' 0000 00-- ---- ---- ---- ---- ---- ----
Const MASK_Z& = &H2000000    ' ---- --Z- ---- ---- ---- ---- ---- ----
Const MASK_C& = &H1000000    ' ---- ---C ---- ---- ---- ---- ---- ----
Const MASK_W& = &H800000     ' ---- ---- W--- ---- ---- ---- ---- ----
Const MASK_I& = &H400000     ' ---- ---- -I-- ---- ---- ---- ---- ----
Const MASK_F& = &H3C0000     ' ---- ---- --FF FF-- ---- ---- ---- ----
Const MASK_D& = &H3FE00      ' ---- ---- ---- --DD DDDD DDD- ---- ----
Const MASK_S& = &H1FF&       ' ---- ---- ---- ---- ---- ---S SSSS SSSS

Dim nam$
Dim i&
Dim useRhs
Dim effect$
Dim c$
Dim wBit As Boolean
Dim link&

  If (eeprom&(here&) And MARK_ORG0) <> 0 Then
    org& = here&
  End If

  eepTxt$ = ""

  pc& = here&
  opc& = GetQuad&

  If createListing Then
    orgTxt$ = FNhex$(here&, 4) + "   " + FNhex$((here& - org&) \ 4, 3)
    oprTxt$ = ""
  Else
    If flgDebugAsmb Then Call Debug_Print("Asmb " + FNhex$(here&, 4) + " " + FNhex$((here& - org&) \ 4, 3) + " ")
  End If

  If Asmb_IsAsmbData(here&) Then

    Call DisAsm_Mode(MODE_ADAT)
    If createListing Then
      opcTxt$ = Space$(15)
      oprTxt$ = "LONG     "
      If opc& < 16 Then
        oprTxt$ = oprTxt$ + FNstr$(opc)
      Else
        oprTxt$ = oprTxt$ + "$" + FNhex$(opc&, (Len(Hex$(opc&)) \ 2) * 2)
      End If
    End If

    Exit Sub

  End If

  Call DisAsm_Mode(MODE_ASMB)

  oprTxt$ = ""

  If opc& = 0 Then
    opcTxt$ = ifs_nam$(15) + "NOP"
  Else

    asmSrc& = opc& And &H1FF
    asmDst& = FNshr&(opc&, 9) And &H1FF

    wBit = (opc& And MASK_W) <> 0

    nam$ = asm_nam$(FNshr&(opc&, 26))
    While Left$(nam$, 1) = "?"
      i& = InStr(2, nam$, Left$(nam$, 2))
      Select Case Mid$(nam$, 2, 1)
        Case "w":  useRhs = opc& And MASK_W
                   wBit = wBit Xor useRhs
        Case "i":  useRhs = opc& And MASK_I
        Case "p":  useRhs = callPair&(org& + (asmDst& * 4)) <> org + (asmSrc& * 4) Or _
                            callPair&(org& + (asmSrc& * 4)) <> org + (asmDst& * 4)
        Case Else: useRhs = Hex$(opc& And 7) <> Mid$(nam$, 2, 1)
      End Select
      If useRhs Then
        nam$ = Right$(nam$, Len(nam$) - (i& + 1))
      Else
        nam$ = Mid$(nam$, 3, i& - 3)
      End If
    Wend

    If createListing Then
      i& = InStr(nam$, " ")
      If i& = 0 Then
        opcTxt$ = nam$
      Else
        opcTxt$ = FNpad$(Left$(nam$, i& - 1), PAD_OPR)
        i& = i& + 1
        While i& <= Len(nam$)
          c$ = Mid$(nam$, i&, 1)
          i& = i& + 1
          Select Case c$

            Case "d", "c"

              If asmDst& >= &H1F0 Then
                opcTxt$ = opcTxt$ + reg_nam$(asmDst& And &H1F)
              Else
                Call Asmb_Finalise_Mark&(asmDst&)
                If flgShowLabels Then
                  opcTxt$ = opcTxt$ + Label_Asmb$(org&, asmDst&)
                Else
                  opcTxt$ = opcTxt$ + Label_Default$(LABEL_TYPE_ASMB, 0, asmDst&)
                End If
              End If

            Case "s"

              If (opc& And MASK_I) <> 0 Then
                opcTxt$ = opcTxt$ + "#" + FNliteral$(asmSrc&, True)
              Else
                If asmSrc& >= &H1F0 Then
                  opcTxt$ = opcTxt$ + reg_nam$(asmSrc& And &H1F)
                Else
                  Call Asmb_Finalise_Mark&(asmSrc&)
                  opcTxt$ = opcTxt$ + Label_Asmb$(org&, asmSrc&)
                End If
              End If

            Case "j"

              opcTxt$ = opcTxt$ + Label_Asmb$(org&, asmSrc&)

             Case "r"

              If (eeprom&(here&) And MARK_ARET) <> 0 And (opc& And (MASK_D Or MASK_S)) = 0 Then
                opcTxt$ = "RET"
                oprTxt$ = "_"
              Else
                opcTxt$ = opcTxt$ + Label_Asmb$(org&, asmSrc&)
              End If

            Case "m"

              If flgShowLabels Then
                opcTxt$ = opcTxt$ + DisAsm_CastVariable$(Label_Spin$(asmSrc&), Mid$(opcTxt$, 3, 4))
              Else
                opcTxt$ = opcTxt$ + "$" + FNhex$(asmSrc&, 3)
              End If

            Case ","

              opcTxt$ = opcTxt$ + ", "

            Case "e", "*"

            Case Else

              opcTxt$ = opcTxt$ + c$

          End Select
        Wend
      End If

      If createListing Then
        opcTxt$ = ifs_nam$(FNshr&(opc&, 18) And &HF) + opcTxt$
      End If

      effect$ = ""
      If (opc& And &H800000) <> 0 Then
        If Not wBit Then
          effect$ = effect$ + "WR"
        End If
      Else
        If wBit Then
          effect$ = effect$ + "NR"
        End If
      End If
      If (opc& And &H1000000) <> 0 Then
        If effect$ <> "" Then
          effect$ = effect$ + ", "
        End If
        effect$ = effect$ + "WC"
      End If
      If (opc& And &H2000000) <> 0 Then
        If effect$ <> "" Then
          effect$ = effect$ + ", "
        End If
        effect$ = effect$ + "WZ"
      End If
      If effect$ <> "" Then
        opcTxt$ = opcTxt$ + " " + effect$
      End If

    Else

      i& = InStr(nam$, " ")
      If i& = 0 Then
        opcTxt$ = nam$
        If flgDebugAsmb Then Call Debug_PrintCrLf(opcTxt$)
      Else
        opcTxt$ = Left$(nam$, i& - 1)
        If flgDebugAsmb Then Call Debug_Print(FNpad$(opcTxt$, 8) + FNhex$(asmDst&, 3) + ", ")
        If (opc& And MASK_I) <> 0 Then
          If flgDebugAsmb Then Call Debug_Print("#")
        End If
        If flgDebugAsmb Then Call Debug_PrintCrLf(FNhex$(asmSrc&, 3))
        For i& = i& + 1 To Len(nam$)
          c$ = Mid$(nam$, i&, 1)
          Select Case c$

            Case "d"

              If opr& < &H1F0 Then
                opr& = org& + (asmDst& * 4)
                Call Mark(opr&, MARK_ASMB Or MARK_ADAT)
             End If

            Case "s"

              If (opc& And MASK_I) = 0 Then
                If asmSrc& < &H1F0 Then
                  opr& = org& + (asmSrc& * 4)
                  Call Mark(opr&, MARK_ASMB Or MARK_ADAT)
                End If
              End If

            Case "c", "e"

              link& = org& + (asmDst& * 4)
              Call Mark(link, MARK_ASMB Or MARK_GOTO Or MARK_ARET)
              If (opc& And MASK_I) <> 0 Then
                If flgDebugAsmb Then Call Debug_PrintCrLf("Pair " + FNhex$(org& + (asmSrc& * 4), 4) + " " + FNhex$(asmSrc&, 3))
                If flgDebugAsmb Then Call Debug_PrintCrLf("Pair " + FNhex$(org& + (asmDst& * 4), 4) + " " + FNhex$(asmDst&, 3))
                labels&(link&) = &H80000000 Or (org& + (asmSrc& * 4))
                If callPair(org& + (asmDst& * 4)) = 0 And _
                   callPair(org& + (asmSrc& * 4)) = 0 _
                Then
                  callPair&(org& + (asmDst& * 4)) = org& + (asmSrc& * 4)
                  callPair&(org& + (asmSrc& * 4)) = org& + (asmDst& * 4)
                  callFrom&(org& + (asmSrc& * 4)) = here&
                  callFrom&(org& + (asmDst& * 4)) = here&
                End If
              Else
                labels&(link&) = &H80000000
              End If

            Case "j", "r"

              isJump = True

            Case "*"

              isJump = True
              asmSrc& = -1

            Case "m"

              Select Case Mid$(opcTxt$, 3, 4)
                Case "BYTE": Call Mark(asmSrc, MARK_BYTE)
                Case "WORD": Call Mark(asmSrc, MARK_WORD)
                Case "LONG": Call Mark(asmSrc, MARK_LONG)
              End Select

          End Select
        Next
      End If
    End If
  End If

End Sub
Function PeekByte&(ByVal pc&)
  PeekByte& = eeprom&(pc&) And &HFF
End Function
Function GetByte&()
Dim b&
  b& = eeprom&(pc&) And &HFF
  If createListing Then
    If Len(eepTxt$) <> 0 Then
      eepTxt$ = eepTxt$ + " "
    End If
    eepTxt$ = eepTxt$ + FNhex$(b&, 2)
  Else
    If pc& <> 0 Then
      eeprom&(pc&) = eeprom&(pc&) Or (eeprom&(pc& - 1) And MARK_SPIN)
    End If
  End If
  pc& = pc& + 1
  GetByte& = b&
End Function

Sub Spin_Decode(ByVal here&)
Dim effect$

  orgTxt$ = FNhex$(here&, 4)
  eepTxt$ = ""

  If Not createListing Then
    If flgDebugSpin Then Call Debug_Print("Spin " + FNhex$(here&, 4) + " ")
  End If

  pc& = here&
  opc& = GetByte&

  doneOpc(opc&) = True

  opcTxt$ = opc_nam$(opc&)
  oprTxt$ = ""

  If opc& = 0 Then
    If Not createListing Then
      frameCount& = frameCount& + 1
    End If
  End If

  If Len(opc_arg$(opc&)) = 0 Then
    If Not createListing Then
      If flgDebugSpin Then Call Debug_PrintCrLf(opcTxt$)
    End If
  Else
    Call Spin_Describe(here&, opc_arg$(opc&))
    If Not createListing Then
      If flgDebugSpin Then Call Debug_PrintCrLf(FNpad$(opcTxt$, PAD_OPR) + "$" + FNhex$(opr&, 8) + " / " + FNsigned$(opr&))
    End If
  End If

  If opcTxt$ = "USING" Then
    opc& = GetByte&
    doneEff(opc&) = True
    effect$ = eff_nam$(opc& And &H7F)
    If effect$ = "" Then
      effect$ = "**** $" + FNhex$(opc&, 2)
      If Left$(labTxt$, 1) <> ";" Then
        Call Failed("EFFECT $" + FNhex$(opc&, 2) + " " + opcTxt$)
      End If
    End If
    If createListing Then
      If flgFoldEffects Then
        If (opc& And &H80) <> 0 Then
          opcTxt$ = "PUSH"
          oprTxt$ = oprTxt$ + " " + effect$
        Else
          effect$ = eff_nam$(opc& Or &H80)
          opcTxt$ = effect$
        End If
      Else
        If (opc& And &H80) <> 0 Then
          oprTxt$ = oprTxt$ + " PUSH"
        End If
        oprTxt$ = oprTxt$ + " " + effect$
      End If
    End If
    Select Case effect$
      Case "RPTINCJ", "RPTADDJ"
        opr& = GetByte&
        If (opr& And &H80&) = 0 Then
          If (opr& And &H40&) <> 0 Then
            opr& = opr& - &H80&
          End If
        Else
          opr& = ((opr& And &H7F) * 256) + GetByte&
          If (opr& And &H4000&) <> 0 Then
            opr& = opr& - &H8000&
          End If
        End If
        If createListing Then
          If flgFoldEffects Then
            oprTxt$ = oprTxt$ + ","
          End If
          oprTxt$ = oprTxt$ + " " + Label_Call$(pc&, opr&)
        Else
          Call Mark(pc& + opr&, MARK_GOTO)
        End If
    End Select

  End If

End Sub
Sub Asmb_Found(ByVal here&, Optional ByVal m&)
Const MASK_F& = &H3C0000     ' ---- ---- --FF FF-- ---- ---- ---- ----

  If flgDebugAsmb Then Call Debug_PrintCrLf("Asmb " + FNhex$(here&, 4) + " Starts")

  eeprom&(here&) = eeprom&(here&) And (Not MARK_SPIN)
  Call Mark(here&, MARK_ASMB Or m&)
  While (Not abort)
    If here& > MAX_EEPROM& Then
      Exit Sub
    Else
      If (eeprom&(here&) And MARK_DONE) <> 0 Then
        Exit Sub
      Else
        eeprom&(here&) = eeprom&(here&) And (Not MARK_SPIN)
        Call Mark(here&, MARK_DONE Or MARK_ASMB)
        isJump = False
        Call Asmb_Decode(here&)
        here& = pc&
        If isJump Then
          Select Case opcTxt$
            Case "JMP", "RET"
              ' This greater > 0 not >= to trap possible RET's
              If asmSrc& > 0 Then
                If (opc& And MASK_F&) = MASK_F& Then
                  ' JMP Always
                  here& = org& + (asmSrc& * 4)
                  Call Mark(here&, MARK_GOTO)
                  If flgDebugAsmb Then Call Debug_PrintCrLf("Goto " + FNhex$(here&, 4) + " " + FNhex$(asmSrc&, 3))
                Else
                  ' JMP Sometimes
                  If flgDebugAsmb Then Call Debug_PrintCrLf("Goto " + FNhex$(org& + (asmSrc& * 4), 4) + " " + FNhex$(asmSrc&, 3))
                  Call Asmb_Found(org& + (asmSrc& * 4), MARK_GOTO)
                End If
              Else
                If (opc& And MASK_F&) = MASK_F& Then
                  ' RET Always
                  If flgDebugAsmb Then Call Debug_PrintCrLf("Exit" + vbCrLf)
                  Exit Sub
                Else
                  ' RET Sometimes
                End If
              End If
            Case "JMPRET", "CALL"
              If asmSrc& >= 0 Then
                If flgDebugAsmb Then Call Debug_PrintCrLf("Call " + FNhex$(org& + (asmSrc& * 4), 4) + " " + FNhex$(asmSrc&, 3))
                Call Asmb_Found(org& + (asmSrc& * 4), MARK_CALL)
              End If
            Case Else
              If asmSrc& >= 0 Then
                If flgDebugAsmb Then Call Debug_PrintCrLf("Call " + FNhex$(org& + (asmSrc& * 4), 4) + " " + FNhex$(asmSrc&, 3))
                Call Asmb_Found(org& + (asmSrc& * 4), MARK_JMPT)
              End If
          End Select
        End If
      End If
    End If
  Wend
  If flgDebugAsmb Then Call Debug_PrintCrLf("Asmb " + FNhex$(here&, 4) + " Done" + vbCrLf)
End Sub
Sub Spin_Found(ByVal here&, Optional ByVal m&)
Dim link&
Dim wasHere&
  If here& > lastPc& Then
    Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4))
  Else
    frameCount& = 0
    eeprom&(here&) = eeprom&(here&) And (Not MARK_ASMB)
    Call Mark(here&, MARK_SPIN Or m&)
    asmbMarker& = 0
    While Not abort
      If here& > lastPc& Then
        Exit Sub
      Else
        If (eeprom&(here&) And MARK_DONE) <> 0 Then
          If flgDebugSpin Then Call Debug_PrintCrLf("Spin " + FNhex$(here&, 4) + " Done" + vbCrLf)
          Exit Sub
        End If
        If frameCount& >= 5 Then
          frameCount& = 0
          If flgDebugSpin Then Call Debug_PrintCrLf("Spin " + FNhex$(here&, 4) + " Abort due to excessive FRAME opcodes" + vbCrLf)
          Exit Sub
        End If
        wasHere& = here&
        eeprom&(here&) = eeprom&(here&) And (Not MARK_ASMB)
        Call Mark(here&, MARK_DONE Or MARK_SPIN)
        isJump = False
        Call Spin_Decode$(here&)
        here& = pc&
        If isJump Then
          Select Case opcTxt$
            Case "CALL"
              pc& = oBase& + (opr& * 4)
              If pc& > MAX_EEPROM Then
                Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4))
              Else
                While pc& >= oBase&
                  Call Mark(pc&, MARK_DONE Or MARK_LINK)
                  pc& = pc& - 4
                Wend
                pc& = oBase& + (opr& * 4)
                link& = PeekLink&(opr&)
                If link& > MAX_EEPROM Then
                  Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4))
                Else
                  callFrom(link&) = wasHere&
                  If flgDebugSpin Then Call Debug_PrintCrLf("Call " + FNhex$(link&, 4) + " via Link at $" + FNhex$(pc&, 4) + " " + FNsigned$(opr&) + vbCrLf)
                  If frameIsForFunction Then
                    Call Spin_Found(link&, MARK_CALL Or MARK_XFUN)
                  Else
                    Call Spin_Found(link&, MARK_CALL)
                  End If
                End If
              End If
              pc& = here&
            Case "GOTO"
              link& = here& + opr&
              If link& > MAX_EEPROM Then
                Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4))
              Else
                Call Mark(link&, MARK_GOTO)
                callFrom(link&) = wasHere&
                If flgDebugSpin Then Call Debug_PrintCrLf("Goto " + FNhex$(link&, 4) + " " + FNsigned$(opr&))
              End If
            Case "JPT", "DJNZ", "TJZ", "TJNZ"
              link& = here& + opr&
              If link& > MAX_EEPROM Then
                Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4) + vbCrLf + opcTxt$)
              Else
                callFrom(link&) = wasHere&
                If flgDebugAsmb Then Call Debug_PrintCrLf("JmpT " + FNhex$(link&, 4) + " " + FNsigned$(opr&))
                Call Spin_Found(link&, MARK_JMPT)
              End If
            Case "JPF", "LOOPJPF"
              link& = here& + opr&
              If link& > MAX_EEPROM Then
                Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4) + vbCrLf + opcTxt$)
              Else
                callFrom(link&) = wasHere&
                If flgDebugSpin Then Call Debug_PrintCrLf("JmpF " + FNhex$(link&, 4) + " " + FNsigned$(opr&))
                Call Spin_Found(link&, MARK_JMPF)
              End If
            Case "LOOPRPT"
              link& = here& + opr&
              If link& > MAX_EEPROM Then
                Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4) + vbCrLf + opcTxt$)
              Else
                Call Mark(link&, MARK_GOTO)
                callFrom(link&) = wasHere&
                here& = link&
                If flgDebugSpin Then Call Debug_PrintCrLf("Goto " + FNhex$(link&, 4) + " " + FNsigned$(opr&))
              End If
            Case "CASE", "CASER"
              link& = here& + opr&
              If link& > MAX_EEPROM Then
                Call Failed("Destination out of range" + vbCrLf + vbCrLf + FNhex$(here&, 4) + vbCrLf + opcTxt$)
              Else
                If flgDebugSpin Then Call Debug_PrintCrLf("JmpT " + FNhex$(link&, 4) + " " + FNsigned$(opr&) + vbCrLf)
                Call Spin_Found(link&, MARK_GOTO)
              End If
            Case "GOTO[]"
               Call Mark(here&, MARK_GOTO)
            Case "COGISUB", "COGIFUN"
              If asmbMarker& > 0 Then
                If flgDebugSpin Then Call Debug_PrintCrLf("Call Asmb")
                Call Asmb_Found_Org0(oBase& + asmbMarker&)
''                If pushMarker&(3) <> 0 Then
                  asmbMarker& = 0
''                End If
              Else
                If pushMarker&(1) >= 0 Then
                  If pushMarker&(2) >= 0 Then
                    If pushMarker&(3) >= 0 Then
                      If pushMarker&(3) = 0 Then
                        asmbMarker& = -1
                      End If
                      Call Asmb_Found_Org0(pushMarker&(2))
                    End If
                  End If
                End If
              End If
              If asmbMarker& <> 0 Then
                asmbMarker& = 0
                Exit Sub
              End If
              
            Case "RETURN", "RETVAL", "ABORT", "ABOVAL"
              If flgDebugSpin Then Call Debug_PrintCrLf("Exit" + vbCrLf)
              Exit Sub
            Case "CALLOBJ"
              Call Spin_Found_Object(opr& \ 256, opr& And &HFF)
              pc& = here&
          End Select
        End If
      End If
    Wend
  End If
End Sub
Sub Spin_Found_Object(ByVal objOffset&, ByVal subOffset&)
Dim oBasePush&
Dim vBasePush&
Dim pc&

  oBasePush& = oBase&
  vBasePush& = vBase&

  ' Mark this as a link and all those earlier to it

  pc& = oBase& + (objOffset& * 4)
  While pc& >= oBase&
    Call Mark(pc&, MARK_DONE Or MARK_LINK)
    pc& = pc& - 4
  Wend

  ' Now to adjust the variable base for the called object. At this point
  ' oBase hasn't been adjusted.

  vBase& = vBase& + PeekLinkSize&(objOffset&)

  ' Now we can adjust oBase for the new object

  oBase& = PeekLink&(objOffset&)

  ' Mark this as an object

  Call Mark(oBase&, MARK_DONE Or MARK_LINK Or MARK_XOBJ)

  ' We now point to the object and can mark the call and all earlier as
  ' links

  pc& = oBase& + (subOffset& * 4)
  While pc& > oBase&
    Call Mark(pc&, MARK_DONE Or MARK_LINK)
    pc& = pc& - 4
  Wend

  ' We know the first link in an object is a call to a public method in
  ' the object so we can traverse that. Very handy for decoding the first
  ' routine in test programs

  If frameIsForFunction Then
    Call Spin_Found(PeekLink&(1), MARK_CALL Or MARK_XFUN)
  Else
    Call Spin_Found(PeekLink&(1), MARK_CALL)
  End If

  ' Now get the address of the routine we are ultimately calling

  pc& = PeekLink&(subOffset&)

  ' Mark it as a sub or function and traverse its code

  If frameIsForFunction Then
    Call Spin_Found(pc&, MARK_CALL Or MARK_XFUN)
  Else
    Call Spin_Found(pc&, MARK_CALL)
  End If

  ' Restore ourselves to the calling object's state

  oBase& = oBasePush&
  vBase& = vBasePush&

End Sub

Sub Spin_Describe(ByVal here&, ByVal argTxt$)
Dim i&
Dim c$
Dim b&
Dim varAdr&
Dim varTyp&

  varAdr& = -1

  pushMarker&(3) = pushMarker&(2)
  pushMarker&(2) = pushMarker&(1)
  pushMarker&(1) = pushMarker&(0)
  pushMarker&(0) = -1
  
  i& = 1
  While i& <= Len(argTxt$)
    c$ = Mid$(argTxt$, i&, 1)
    i& = i& + 1
    Select Case c$

      Case "a"                                      ' Address

        isJump = True
        opr& = GetByte&
        If (opr& And &H80&) = 0 Then
          If (opr& And &H40&) <> 0 Then
            opr& = opr& - &H80&
          End If
        Else
          opr& = ((opr& And &H7F) * 256) + GetByte&
          If (opr& And &H4000&) <> 0 Then
            opr& = opr& - &H8000&
          End If
        End If
        If createListing Then
          oprTxt$ = oprTxt$ + Label_Call$(pc&, opr&)
        End If

      Case "b"                                      ' Byte variable

        If createListing Then
          oprTxt$ = DisAsm_CastVariable(oprTxt$, "BYTE")
        Else
          Call Spin_Found_Var(here&, varTyp&, varAdr&, MARK_BYTE, "Byte")
        End If

      Case "c"                                      ' Call address

        isJump = True
        opr& = GetByte&
        If createListing Then
          If flgShowLabels Then
            oprTxt$ = oprTxt$ + Label_Spin$(PeekLink&(opr&))
          Else
            oprTxt$ = oprTxt$ + FNsigned$(opr&)
          End If
        End If

      Case "d"                                      ' Direct variable address

        varAdr& = opc& And &H1C
        varTyp& = Spin_GetVarTyp&(argTxt$, i&)
        If createListing Then
          If flgShowLabels Then
            oprTxt$ = Label_Var$(oprTxt$, varTyp&, varAdr&)
          Else
            oprTxt$ = oprTxt$ + FNstr$(varAdr&)
          End If
        End If

      Case "f"                                      ' Frame

        c$ = Mid$(argTxt$, i&, 1)
        i& = i& + 1
        frameIsForFunction = (c$ = "+")

      Case "k"                                      ' Literal constant LSB first

        c$ = Mid$(argTxt$, i&, 1)
        i& = i& + 1
        Select Case c$
          Case "1": opr& = GetByte& ' 8-bit
          Case "2": opr& = GetWord& ' 16-bit
          Case "3": opr& = GetLong& ' 24-bit
          Case "4": opr& = GetQuad& ' 32-bit
          Case "s": opr& = GetQuad& ' Stack word
          Case "<":
            c$ = Mid$(argTxt$, i&, 1)
            i& = i& + 1
            opr& = GetByte&
            Select Case c$
              Case "2": opr& = FNshl&(opr&, 8) Or GetByte& ' 16-bit
              Case "3": opr& = FNshl&(opr&, 8) Or GetByte& ' 24-bit
                        opr& = FNshl&(opr&, 8) Or GetByte&
              Case "4": opr& = FNshl&(opr&, 8) Or GetByte& ' 32-bit
                        opr& = FNshl&(opr&, 8) Or GetByte&
                        opr& = FNshl&(opr&, 8) Or GetByte&
            End Select
          Case "c"
            opr& = GetByte& ' 8-bit char
          Case "p"

            ' Biffle describes this as ...
            ' Push literal longword 2^(p+1) - d onto the stack.
            ' ( -- (2^(p+1))-d )
            ' but what does he think 'd' is ???

            b& = GetByte&
            opr& = FNshl&(2, b& And &H1F)
            If (b& And &H80) <> 0 Then

If createListing Then
  oprTxt$ = oprTxt$ + " ***** [WRONG] ***** "
  If Left$(labTxt$, 1) <> ";" Then
    Call Failed("PACKED CONSTANT ERROR")
  End If
End If
            Else
              If (b& And &H20) <> 0 Then
                If opr& = &H80000000 Then
                  opr& = &H7FFFFFFF
                Else
                  opr& = opr& - 1
                End If
              End If
              If (b& And &H40) <> 0 Then
                opr& = opr& Xor &HFFFFFFFF
              End If
            End If
        End Select
        If (opr& And &HFFFF0000) = 0 Then
          pushMarker&(0) = opr&
        End If
        
        If createListing Then
          If Right$(oprTxt$, 1) = "$" Then
            Select Case c$
              Case "1": oprTxt$ = oprTxt$ + FNhex$(opr&, 2)
              Case "2": oprTxt$ = oprTxt$ + FNhex$(opr&, 4)
              Case "3": oprTxt$ = oprTxt$ + FNhex$(opr&, 6)
              Case "4": oprTxt$ = oprTxt$ + FNhex$(opr&, 8)
              Case Else: oprTxt$ = oprTxt$ + FNhex$(opr&, ((Len(Hex$(opr&)) + 1) \ 2) * 2)
            End Select
          Else
            If c$ = "c" Then
              If opr& >= 32 And opr& <= &H7E Then
                oprTxt$ = oprTxt$ + """" + Chr$(opr&) + """            ; " + FNstr$(opr&)
              Else
                oprTxt$ = oprTxt$ + FNliteral$(opr&)
              End If
            Else
              oprTxt$ = oprTxt$ + FNliteral$(opr&)
            End If
          End If
        End If

      Case "l"                                      ' Long variable

        If createListing Then
          oprTxt$ = DisAsm_CastVariable(oprTxt$, "LONG")
        Else
          Call Spin_Found_Var(here&, varTyp&, varAdr&, MARK_LONG, "Long")
        End If

      Case "m"

        If Mid$(argTxt$, i&, 1) = "#" Then
          Select Case Mid$(argTxt$, i& + 1, 1)
            Case "0": pushMarker&(0) = 0
            Case "1": pushMarker&(0) = 1
          End Select
        Else
          asmbMarker& = opr&
        End If
        
      Case "p"                                      ' Object Pair

        isJump = True
        opr& = GetByte                              ' Link to Obj
        If createListing Then
          If flgShowLabels Then
            oprTxt$ = oprTxt$ + Label_Spin$(PeekLink&(opr&))
          Else
            oprTxt$ = oprTxt$ + FNsigned$(opr&)
          End If
        End If

        If Mid$(argTxt$, i&, 1) = "[" Then
          oprTxt$ = oprTxt$ + "[]"
          i& = i& + 2
        End If

        oprTxt$ = oprTxt$ + ", "

        b& = GetByte                                ' Link within Obj
        opr& = (opr& * 256) Or b&
        If createListing Then
''          If flgShowLabels Then
''            oprTxt$ = oprTxt$ + Spin_LookupLabel$(PeekLink&(b&))
''          Else
            oprTxt$ = oprTxt$ + FNsigned$(b&)
''          End If
        End If

      Case "r"                                      ' Register

        b& = GetByte&
        Select Case b& And &HE0
          Case &H80: opcTxt$ = "PUSH"
          Case &HA0: opcTxt$ = "POP"
          Case &HC0: opcTxt$ = "USING"
          Case Else: opcTxt$ = "?"
        End Select
        If createListing Then
          b& = b& And &H1F
          If b& > &HF Then
            oprTxt$ = oprTxt$ + reg_nam$(b&)
          Else
            If flgNoDefaultLong Then
              If flgCastVariables Then
                oprTxt$ = oprTxt$ + "LONG(" + reg_nam$(b&) + ")"
              Else
                oprTxt$ = oprTxt$ + reg_nam$(b&) + ".LONG"
              End If
            Else
              oprTxt$ = oprTxt$ + reg_nam$(b&)
            End If
          End If
        End If

      Case "u"

        asmbMarker& = 0

      Case "v"                                      ' Var Offset

        opr& = GetByte&
        If (opr& And &H80) <> 0 Then
          opr& = ((opr& And &H7F) * 256) Or GetByte&
        End If
        varAdr& = opr&
        varTyp& = Spin_GetVarTyp&(argTxt$, i&)
        If createListing Then
          If flgShowLabels Then
            oprTxt$ = Label_Var$(oprTxt$, varTyp&, varAdr&)
          Else
            oprTxt$ = oprTxt$ + FNstr$(opr&)
          End If
        End If

      Case "w"                                      ' Word variable

        If createListing Then
          oprTxt$ = DisAsm_CastVariable(oprTxt$, "WORD")
        Else
          Call Spin_Found_Var(here&, varTyp&, varAdr&, MARK_WORD, "Word")
        End If

      Case "x"

        opr& = GetQuad& + oBase&
        If createListing Then
          If flgShowLabels Then
            If (opr& And &HFFFF&) = vMain& Then
              oprTxt$ = oprTxt$ + "VBASE"
            Else
              oprTxt$ = oprTxt$ + Label_Spin$(opr& And &HFFFF&)
            End If
          Else
            oprTxt$ = oprTxt$ + "$" + FNhex$(opr& And &HFFFF&, 4)
          End If
          If (opr& And &HFFFF0000) <> 0 Then
            oprTxt$ = oprTxt$ + ", " + FNstr$(FNshr&(opr&, 16))
          End If
        End If

      Case "y"                                      ' Clock Mode

        b& = GetByte&
        If createListing Then
          Select Case b& And 7
            Case 0
              oprTxt$ = oprTxt$ + "RCFAST"
              If b& <> &H0 Then
                oprTxt$ = oprTxt$ + " - Invalid Bit Settings !"
              End If
            Case 1
              oprTxt$ = oprTxt$ + "RCSLOW"
              If b& <> &H1 Then
                oprTxt$ = oprTxt$ + " - Invalid Bit Settings !"
              End If
            Case Else
              If (b& And &HA0) <> &H20 Then
                oprTxt$ = oprTxt$ + "Invalid Bit Settings !"
              Else
                Select Case b& And &H18
                  Case &H0: oprTxt$ = oprTxt$ + "XINPUT"
                  Case &H8: oprTxt$ = oprTxt$ + "XTAL1"
                  Case &H10: oprTxt$ = oprTxt$ + "XTAL2"
                  Case &H18: oprTxt$ = oprTxt$ + "XTAL3"
                End Select
                If b& And &H40 Then
                  Select Case b& And 7
                    Case 3: oprTxt$ = oprTxt$ + "_PLL1x"
                    Case 4: oprTxt$ = oprTxt$ + "_PLL2x"
                    Case 5: oprTxt$ = oprTxt$ + "_PLL4x"
                    Case 6: oprTxt$ = oprTxt$ + "_PLL8x"
                    Case 7: oprTxt$ = oprTxt$ + "_PLL16x"
                    Case Else
                      oprTxt$ = oprTxt$ + " - Invalid Bit Settings !"
                  End Select
                End If
              End If

          End Select
        End If

      Case "#"

        If createListing Then
          If Mid$(argTxt$, i&, 1) = "#" Then
            i& = i& + 1
            oprTxt$ = oprTxt$ + "#"
          Else
            If flgForceHash Then
              oprTxt$ = oprTxt$ + "#"
            End If
          End If
        End If

      Case "*"

        isJump = True

      Case ","

        If createListing Then
          oprTxt$ = oprTxt$ + ", "
        End If

      Case Else

        If createListing Then
          oprTxt$ = oprTxt$ + c$
        End If

    End Select
  Wend
End Sub
Sub Spin_Found_Var(ByVal pc&, ByVal varTyp&, ByVal varAdr&, ByVal m&, ByVal typ$)
  If varAdr& >= 0 Then
    Select Case varTyp&
      Case VARTYPE_MEM:
       Call Mark(varAdr&, MARK_DONE Or m&)
      Case VARTYPE_OBJ:
        varAdr& = varAdr& + oBase&
        Call Mark(varAdr&, MARK_DONE Or m&)
      Case VARTYPE_VAR:
        If vBase& >= 0 Then
          varAdr& = varAdr& + vBase&
          Call Mark(varAdr&, MARK_DONE Or m&)
        End If
      Case VARTYPE_LOC
        varsUsed&(pc&) = FNshl&(varTyp& Or m&, 16) Or varAdr&
        If flgDebugVars Then Call Debug_PrintLater(typ$ + " " + FNhex$(varAdr& + vBase&, 4) + " " + FNstr$(varAdr&))
    End Select
  End If
End Sub

Function DisAsm_CastVariable$(ByVal var$, ByVal typ$)
  If flgNoDefaultLong Or (typ$ <> "LONG") Then
    If flgCastVariables Then
      If Left$(var$, 1) = "#" Then
        var$ = "#" + typ$ + "(" + Right$(var$, Len(var$) - 1) + ")"
      Else
        var$ = typ$ + "(" + var$ + ")"
      End If
    Else
      var$ = var$ + "." + typ$
    End If
  End If
  DisAsm_CastVariable$ = var$
End Function

Sub Spin_Register_Add(ByVal nam$)
Static opc_top&
  If nam$ = "" Then
    reg_nam$(opc_top&) = FNstr$(opc_top&)
  Else
    reg_nam$(opc_top&) = nam$
  End If
  opc_top& = opc_top& + 1
End Sub
Sub Spin_Effect_Add(ByVal eff&, ByVal nam$)
Dim i&
  i& = InStr(nam$, " ")
  If i& = 0 Then
    eff_nam$(eff&) = nam$
    eff_nam$(eff& Or &H80) = nam$
  Else
    eff_nam$(eff&) = Left$(nam$, i& - 1)
    eff_nam$(eff& Or &H80) = Right$(nam$, Len(nam$) - i&)
  End If
  If eff& < &H40 Then
    If (eff& And 3) = 0 Then
      Call Spin_Effect_Add(eff& + 1, nam$)
      Call Spin_Effect_Add(eff& + 2, nam$)
      Call Spin_Effect_Add(eff& + 3, nam$)
    End If
  End If
End Sub
Sub Spin_Add(ByVal nam$)
Static opc_top&
Dim i&
Dim arg$
  If nam$ = "" Then
    opc_nam$(opc_top&) = FNstr$(opc_top&)
  Else
    i& = InStr(nam$, " ")
    If i& = 0 Then
      opc_nam$(opc_top&) = nam$
      opc_arg$(opc_top&) = ""
    Else
      opc_nam$(opc_top&) = Left$(nam$, i& - 1)
      opc_arg$(opc_top&) = LTrim$(Right$(nam$, Len(nam$) - i&))
    End If
  End If
  opc_top& = opc_top& + 1
End Sub
Sub Spin_Init()
Dim i&
Dim a&
Dim b&
Dim c&
Dim t$

  ' Operand decoders ...
  '
  ' a               : address offset
  ' c               : call address vector offset
  ' d               : Direct variable address
  ' f+, f-          : Frame type ( + = Func, - = Sub )
  ' k1, k2, k3, k4  : literal constants LSB first
  ' k<2, k<3, k<4   : literal constants MSB first
  ' kp              : packed literal constant
  ' ks              : literal constant in stack area
  ' m               : mark asmb address
  ' p               : object pair
  ' r               : register
  ' u               : unmark assembler address
  ' v               : variable offset
  ' y               : clock mode bits
  ' _               : Put blank line after opcode ( must be last in text )

  Call Spin_Add("FRAME   f+CALL WITH RETURN VALUE")                   ' 0
  Call Spin_Add("FRAME   f-CALL WITHOUT RETURN VALUE") ' FRAME_CALL_NORETURN                  ' 1
  Call Spin_Add("FRAME   f-CALL WITH ABORT TRAP")      ' FRAME_CALL_ABORT                     ' 2
  Call Spin_Add("FRAME   f-CALL IGNORING ABORT TRAP")  ' FRAME_CALL_TRASHABORT                ' 3
  Call Spin_Add("GOTO    a")            ' BRANCH" , %SignedOffset )                   ' 4
  Call Spin_Add("CALL    c")           ' CALL" , %Literal8Bit )                      ' 5
  Call Spin_Add("CALLOBJ pu")            ' OBJCALL" , %ObjCallPair )                   ' 6
  Call Spin_Add("CALLOBJ p[]u")           ' OBJCALL_INDEXED" , %ObjCallPair )           ' 7
  Call Spin_Add("LOOPJPF a>")           ' LOOP_START" , %SignedOffset )               ' 8
  Call Spin_Add("LOOPRPT a<")           ' LOOP_CONTINUE" , %SignedOffset )            ' 9
  Call Spin_Add("JPF     a")            ' JUMP_IF_FALSE" , %SignedOffset )            ' 10
  Call Spin_Add("JPT     a")            ' JUMP_IF_TRUE" , %SignedOffset )             ' 11
  Call Spin_Add("GOTO[]  *")              ' JUMP_FROM_STACK                      ' 12
  Call Spin_Add("CASE    a")            ' COMPARE_CASE" , %SignedOffset )             ' 13
  Call Spin_Add("CASER   a")      ' COMPARE_CASE_RANGE" , %SignedOffset )       ' 14
  Call Spin_Add("LOOKEND")         ' LOOK_ABORT                           ' 15
  Call Spin_Add("LOOKUP")               ' LOOKUP_COMPARE                       ' 16
  Call Spin_Add("LOOKDN")               ' LOOKDOWN_COMPARE                     ' 17
  Call Spin_Add("LOOKUPR")        ' LOOKUPRANGE_COMPARE                  ' 18
  Call Spin_Add("LOOKDNR")        ' LOOKDOWNRANGE_COMPARE                ' 19
  Call Spin_Add("QUIT???") ' 20
  Call Spin_Add("MARK    u")              ' MARK_INTERPRETED                     ' 21
  Call Spin_Add("STRSIZE")              ' STRSIZE                              ' 22
  Call Spin_Add("STRCOMP")              ' STRCOMP                              ' 23
  Call Spin_Add("BYTEFIL")              ' BYTEFILL                             ' 24
  Call Spin_Add("WORDFIL")              ' WORDFILL                             ' 25
  Call Spin_Add("LONGFIL")              ' LONGFILL                             ' 26
  Call Spin_Add("WAITPEQ")              ' WAITPEQ                              ' 27
  Call Spin_Add("BYTEMOV")              ' BYTEMOVE                             ' 28
  Call Spin_Add("WORDMOV")              ' WORDMOVE                             ' 29
  Call Spin_Add("LONGMOV")              ' LONGMOVE                             ' 30
  Call Spin_Add("WAITPNE")              ' WAITPNE                              ' 31
  Call Spin_Add("CLKSET")               ' CLKSET                               ' 32
  Call Spin_Add("COGSTOP")              ' COGSTOP                              ' 33
  Call Spin_Add("LRETSUB")              ' LOCKRET                              ' 34
  Call Spin_Add("WAITCNT")              ' WAITCNT                              ' 35
  Call Spin_Add("PUSH    SPR[]")        ' READ_INDEXED_SPR                     ' 36
  Call Spin_Add("POP     SPR[]")        ' WRITE_INDEXED_SPR                    ' 37
  Call Spin_Add("USING   SPR[]")        ' EFFECT_INDEXED_SPR" , %Effct )             ' 38
  Call Spin_Add("WAITVID")              ' WAITVID                              ' 39
  Call Spin_Add("COGIFUN *")      ' COGINIT_RETURNS                      ' 40
  Call Spin_Add("LNEWFUN")      ' LOCKNEW_RETURNS                      ' 41
  Call Spin_Add("LSETFUN")      ' LOCKSET_RETURNS                      ' 42
  Call Spin_Add("LCLRFUN")      ' LOCKCLR_RETURNS                      ' 43
  Call Spin_Add("COGISUB *")              ' COGINIT                              ' 44
  Call Spin_Add("LNEWSUB")              ' LOCKNEW                              ' 45
  Call Spin_Add("LSETSUB")              ' LOCKSET                              ' 46
  Call Spin_Add("LCLRSUB")              ' LOCKCLR                              ' 47
  Call Spin_Add("ABORT   *")                ' ABORT                                ' 48
  Call Spin_Add("ABOVAL  *")       ' ABORT_WITH_RETURN                    ' 49
  Call Spin_Add("RETURN  *u_")            ' RETURN                               ' 50
  Call Spin_Add("RETVAL  *u_")          ' POP_RETURN                           ' 51
  Call Spin_Add("PUSH    m#-1")          ' PUSH_NEG1                            ' 52
  Call Spin_Add("PUSH    m#0")           ' PUSH_0                               ' 53
  Call Spin_Add("PUSH    m#1")           ' PUSH_1                               ' 54
  Call Spin_Add("PUSH    #kp")          ' PUSH_LIT_PACKED" , %PackedLiteral )         ' 55
  Call Spin_Add("PUSH    #k1")           ' PUSH_LIT_8_BIT" , %Literal8Bit )             ' 56
  Call Spin_Add("PUSH    #k<2")          ' PUSH_LIT_16_BIT" , %Literal16Bit)             ' 57
  Call Spin_Add("PUSH    #k<3")          ' PUSH_LIT_24_BIT" , %Literal24Bit )             ' 58
  Call Spin_Add("PUSH    #k<4")          ' PUSH_LIT_32_BIT" , %Literal32Bit )             ' 59
  Call Spin_Add("?3C")                     ' UNKNOWNOP$3C                         ' 60
  Call Spin_Add("REG     r[]")          ' INDEXED_MEM_OP" , %MemoryOpCode )           ' 61
  Call Spin_Add("REG     r[..]")        ' INDEXED_RANGE_MEM_OP" , %MemoryOpCode )     ' 62
  Call Spin_Add("REG     r")            ' MEMORY_OP" , %MemoryOpCode )                ' 63

  For i& = 0 To 7
    Call Spin_Add("PUSH    VAR+dl") ' PUSH_VARMEM_LONG_1                 ' 100
    Call Spin_Add("POP     VAR+dl") ' POP_VARMEM_LONG_1                  ' 101
    Call Spin_Add("USING   VAR+dl") ' EFFECT_VARMEM_LONG_1" , %Effct )         ' 102
    Call Spin_Add("PUSH    ##VAR+dl") ' REFERENCE_VARMEM_LONG_1            ' 103
  Next

  For i& = 0 To 7
    Call Spin_Add("PUSH    LOC+dl") ' PUSH_LOCALMEM_LONG_1                 ' 100
    Call Spin_Add("POP     LOC+dl") ' POP_LOCALMEM_LONG_1                  ' 101
    Call Spin_Add("USING   LOC+dl") ' EFFECT_LOCALMEM_LONG_1" , %Effct )         ' 102
    Call Spin_Add("PUSH    ##LOC+dl") ' REFERENCE_LOCALMEM_LONG_1            ' 103
  Next

  For a& = 0 To 2
    For b& = 0 To 1
      For c& = 0 To 3
        Select Case c&
          Case 0: t$ = "MEM[]" ' "MEM+v"
          Case 1: t$ = "OBJ+v"
          Case 2: t$ = "VAR+v"
          Case 3: t$ = "LOC+v"
        End Select
        If b& = 1 Then
          t$ = t$ + "[]"
        End If
        Select Case a&
          Case 0: t$ = t$ + "b"
          Case 1: t$ = t$ + "w"
          Case 2: t$ = t$ + "l"
        End Select
        Call Spin_Add("PUSH    " + t$) ' PUSH_MAINMEM_BYTE                    ' 128
        Call Spin_Add("POP     " + t$) ' POP_MAINMEM_BYTE                     ' 129
        Call Spin_Add("USING   " + t$) ' EFFECT_MAINMEM_BYTE" , %Effct )            ' 130
        If t$ = "OBJ+vl" Then
          t$ = t$ + "m"
        End If
        Call Spin_Add("PUSH    ##" + t$) ' REFERENCE_MAINMEM_BYTE               ' 131
      Next
    Next
  Next

  Call Spin_Add("ROR")                  ' ROTATE_RIGHT                         ' 224
  Call Spin_Add("ROL")                  ' ROTATE_LEFT                          ' 225
  Call Spin_Add("SHR")                  ' SHIFT_RIGHT                          ' 226
  Call Spin_Add("SHL")                  ' SHIFT_LEFT                           ' 227
  Call Spin_Add("MIN")                  ' LIMIT_MIN                            ' 228
  Call Spin_Add("MAX")                  ' LIMIT_MAX                            ' 229
  Call Spin_Add("NEG")                  ' NEGATE                               ' 230
  Call Spin_Add("BIT_NOT")              ' COMPLEMENT                           ' 231
  Call Spin_Add("BIT_AND")              ' BIT_AND                              ' 232
  Call Spin_Add("ABS")                  ' ABSOLUTE_VALUE                       ' 233
  Call Spin_Add("BIT_OR")               ' BIT_OR                               ' 234
  Call Spin_Add("BIT_XOR")              ' BIT_XOR                              ' 235
  Call Spin_Add("ADD")                  ' ADD                                  ' 236
  Call Spin_Add("SUB")                  ' SUBTRACT                             ' 237
  Call Spin_Add("SAR")                  ' ARITH_SHIFT_RIGHT                    ' 238
  Call Spin_Add("BIT_REV")              ' BIT_REVERSE                          ' 239
  Call Spin_Add("LOG_AND")              ' LOGICAL_AND                          ' 240
  Call Spin_Add("ENCODE")               ' ENCODE                               ' 241
  Call Spin_Add("LOG_OR")               ' LOGICAL_OR                           ' 242
  Call Spin_Add("DECODE")               ' DECODE                               ' 243
  Call Spin_Add("MPY")                  ' MULTIPLY                             ' 244
  Call Spin_Add("MPY_MSW")              ' MULTIPLY_HIWORD                      ' 245
  Call Spin_Add("DIV")                  ' DIVIDE                               ' 246
  Call Spin_Add("MOD")                  ' MODULO                               ' 247
  Call Spin_Add("SQRT")                 ' SQUARE_ROOT                          ' 248
  Call Spin_Add("LT")                   ' LESS                                 ' 249
  Call Spin_Add("GT")                   ' GREATER                              ' 250
  Call Spin_Add("NE")                   ' NOT_EQUAL                            ' 251
  Call Spin_Add("EQ")                   ' EQUAL                                ' 252
  Call Spin_Add("LE")                   ' LESS_EQUAL                           ' 253
  Call Spin_Add("GE")                   ' GREATER_EQUAL                        ' 254
  Call Spin_Add("LOG_NOT")              ' LOGICAL_NOT                          ' 255

  ' Define the 'Effect' opcodes for Spin

  Call Spin_Effect_Add(&H0, "COPY")
  Call Spin_Effect_Add(&H1, "")
  Call Spin_Effect_Add(&H2, "RPTINCJ")
  Call Spin_Effect_Add(&H3, "")
  Call Spin_Effect_Add(&H4, "")
  Call Spin_Effect_Add(&H4, "")
  Call Spin_Effect_Add(&H6, "RPTADDJ")
  Call Spin_Effect_Add(&H7, "")

  Call Spin_Effect_Add(&H8, "FWDRAND")
  Call Spin_Effect_Add(&HC, "REVRAND")
  Call Spin_Effect_Add(&H10, "SEXBYTE")
  Call Spin_Effect_Add(&H14, "SEXWORD")
  Call Spin_Effect_Add(&H18, "POSTCLR")
  Call Spin_Effect_Add(&H1C, "POSTSET")
  Call Spin_Effect_Add(&H20, "PREINC INC")
  Call Spin_Effect_Add(&H24, "PREINC INC")
  Call Spin_Effect_Add(&H28, "POSTINC INC")
  Call Spin_Effect_Add(&H2C, "POSTINC INC")
  Call Spin_Effect_Add(&H30, "PREDEC DEC")
  Call Spin_Effect_Add(&H34, "PREDEC DEC")
  Call Spin_Effect_Add(&H38, "POSTDEC DEC")
  Call Spin_Effect_Add(&H3C, "POSTDEC DEC")

  Call Spin_Effect_Add(&H40, "ROR")
  Call Spin_Effect_Add(&H41, "ROL")
  Call Spin_Effect_Add(&H42, "SHR")
  Call Spin_Effect_Add(&H43, "SHL")
  Call Spin_Effect_Add(&H44, "MIN")
  Call Spin_Effect_Add(&H45, "MAX")
  Call Spin_Effect_Add(&H46, "NEG")
  Call Spin_Effect_Add(&H47, "BIT_NOT")
  Call Spin_Effect_Add(&H48, "BIT_AND")
  Call Spin_Effect_Add(&H49, "ABS")
  Call Spin_Effect_Add(&H4A, "BIT_OR")
  Call Spin_Effect_Add(&H4B, "BIT_XOR")
  Call Spin_Effect_Add(&H4C, "ADD")
  Call Spin_Effect_Add(&H4D, "SUB")
  Call Spin_Effect_Add(&H4E, "SAR")
  Call Spin_Effect_Add(&H4F, "BIT_REV")
  Call Spin_Effect_Add(&H50, "LOG_AND")
  Call Spin_Effect_Add(&H51, "ENCODE")
  Call Spin_Effect_Add(&H52, "LOG_OR")
  Call Spin_Effect_Add(&H53, "DECODE")
  Call Spin_Effect_Add(&H54, "MPY")
  Call Spin_Effect_Add(&H55, "MPY_BIG")
  Call Spin_Effect_Add(&H56, "DIV")
  Call Spin_Effect_Add(&H57, "MOD")
  Call Spin_Effect_Add(&H58, "SQR")
  Call Spin_Effect_Add(&H59, "LT")
  Call Spin_Effect_Add(&H5A, "GT")
  Call Spin_Effect_Add(&H5B, "NE")
  Call Spin_Effect_Add(&H5C, "EQ")
  Call Spin_Effect_Add(&H5D, "LE")
  Call Spin_Effect_Add(&H5E, "GE")
  Call Spin_Effect_Add(&H5F, "LOG_NOT")

  ' Define the registers for Spin

  For i& = 0 To 15
    Call Spin_Register_Add("MEM+" + FNstr$(i&))
  Next

  Call Spin_Register_Add("PAR")
  Call Spin_Register_Add("CNT")
  Call Spin_Register_Add("INA")
  Call Spin_Register_Add("INB")
  Call Spin_Register_Add("OUTA")
  Call Spin_Register_Add("OUTB")
  Call Spin_Register_Add("DIRA")
  Call Spin_Register_Add("DIRB")
  Call Spin_Register_Add("CTRA")
  Call Spin_Register_Add("CTRB")
  Call Spin_Register_Add("FRQA")
  Call Spin_Register_Add("FRQB")
  Call Spin_Register_Add("PHSA")
  Call Spin_Register_Add("PHSB")
  Call Spin_Register_Add("VCFG")
  Call Spin_Register_Add("VSCL")

End Sub
Function IsLiteral(ByVal opr$) As Boolean
  IsLiteral = InStr("#$0123456789+-", Left$(opr$, 1)) <> 0
End Function

Function IsPushLiteral(ByVal offset&) As Boolean
Dim opr$
  offset& = held& + offset&
  If opcHeld$(offset&) = "PUSH" Then
    opr$ = oprHeld$(offset&)
    If InStr(opr$, "[]") <> 0 Then
      IsPushLiteral = False
    Else
      If InStr(opr$, "[..]") <> 0 Then
        IsPushLiteral = False
      Else
        IsPushLiteral = IsLiteral(opr$)
      End If
    End If
  Else
    IsPushLiteral = False
  End If
End Function

Sub PeepHole_Add()
Dim i&
  #If True Then

    Call PeepHole_Push

    If held& > 1 Then
      If Len(labTxt$) = 0 Then

        If flgFoldIndexes Then
          If InStr(oprTxt, "[][]") <> 0 Then
            If held& > 2 Then
              Call PeepHole_FoldDoubleIndex
            End If
          Else
            If InStr(oprTxt, "[]") <> 0 Then
              Call PeepHole_FoldIndex
            Else
              If held& > 2 Then
                If InStr(oprTxt, "[..]") <> 0 Then
                  Call PeepHole_FoldRangeIndex
                End If
              End If
            End If
          End If
        End If

        If flgFoldOpcodes Then
         Call PeepHole_FoldOpcode
        End If

        If flgFoldSpr Then
          If InStr(oprTxt$, "SPR[]") <> 0 Then
            Call PeepHole_FoldSpr
          End If
        End If

        If flgFoldOperators Then
          Call PeepHole_FoldOperator
        End If

      End If
    End If

  #Else
    Call DisAsm_Print(True)
  #End If

End Sub
Sub PeepHole_Flush()
Dim i&
  If Right$(oprHeld$(held&), 1) = "_" Then
    oprHeld$(held&) = Left$(oprHeld$(held&), Len(oprHeld$(held&)) - 1)
  End If
  For i& = 1 To held&
    Call PeepHole_Print(i&)
  Next
  held& = 0
End Sub
Sub PeepHole_Fold(ByVal opc$, Optional ByVal opr$)
  held& = held& - 1
  eepHeld$(held&) = eepHeld$(held&) + " " + eepHeld$(held& + 1)
  opcHeld$(held&) = opc$
  If Len(opr$) <> 0 Then
    oprHeld$(held&) = opr$
  End If
  opcTxt$ = opc$
  oprTxt$ = oprHeld$(held&)
End Sub

Sub PeepHole_FoldDoubleIndex()
Dim i&
  If opcHeld$(held& - 1) = "PUSH" Then
    If opcHeld$(held& - 2) = "PUSH" Then
      i& = InStr(oprTxt$, "[][]") + 2
      oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + Right$(oprTxt$, Len(oprTxt$) - i&)
      Call PeepHole_Fold(opcTxt$, oprTxt$)
      oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + Right$(oprTxt$, Len(oprTxt$) - i&)
      Call PeepHole_Fold(opcTxt$, oprTxt$)
    End If
  End If
End Sub
Sub PeepHole_FoldIndex()
Dim i&
  If opcHeld$(held& - 1) = "PUSH" Then
    i& = InStr(oprTxt$, "[]")
    oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + Right$(oprTxt$, Len(oprTxt$) - i&)
    Call PeepHole_Fold(opcTxt$, oprTxt$)
  End If
End Sub
Sub PeepHole_FoldOperator()

  Select Case opcTxt$

    Case "CASE"

      If IsPushLiteral(-1) Then
        Call PeepHole_Fold(opcTxt$, oprHeld$(held& - 1) + ", " + oprTxt$)
      End If

    Case "LOOKUP", "LOOKDN"

      If IsPushLiteral(-1) Then
        Call PeepHole_Fold(opcTxt$)
      End If

    Case "CASER", _
         "LOOKUPR", "LOOKDNR", _
         "STRCOMP"

      If held& > 2 Then
        If IsPushLiteral(-1) Then
          If IsPushLiteral(-2) Then
            Select Case opcTxt$
              Case "LOOKUPR": opcTxt$ = "LOOKUP"
              Case "LOOKDNR": opcTxt$ = "LOOKDN"
            End Select
            If opcTxt$ = "CASER" Then
              Call PeepHole_Fold("CASE", oprHeld$(held& - 1) + ", " + oprTxt$)
            Else
              Call PeepHole_Fold(opcTxt$)
            End If
            Call PeepHole_Fold(opcTxt$, oprHeld$(held& - 1) + ", " + oprTxt$)
          End If
        End If
      End If

    Case "BYTEFIL", "WORDFIL", "LONGFIL", _
         "BYTEMOV", "WORDMOV", "LONGMOV"

      If held& > 3 Then
        If IsPushLiteral(-1) Then
          If IsPushLiteral(-2) Then
            If IsPushLiteral(-3) Then
              Call PeepHole_Fold(opcTxt$)
              Call PeepHole_Fold(opcTxt$, oprHeld$(held& - 1) + ", " + oprTxt$)
              Call PeepHole_Fold(opcTxt$, oprHeld$(held& - 1) + ", " + oprTxt$)
            End If
          End If
        End If
      End If

    Case "POP"

      If opcHeld$(held& - 1) = "PUSH" Then
        If InStr(oprTxt$, "[]") = 0 Then
          If InStr(oprTxt$, "[..]") = 0 Then
            If InStr(oprHeld$(held& - 1), "[]") = 0 Then
              If InStr(oprHeld$(held& - 1), "[..]") = 0 Then
                Call PeepHole_Fold("LET", oprTxt$ + ", " + oprHeld$(held& - 1))
              End If
            End If
          End If
        End If
      Else
        Select Case opcHeld$(held& - 1)
          Case "CALLFUN", "OBJFUN"
            Call PeepHole_Fold(opcHeld$(held& - 1), oprHeld$(held& - 1) + ", " + oprTxt$)
          Case "COGIFUN", _
               "LCLRFUN", "LSETFUN"
            Call PeepHole_Fold(opcHeld$(held& - 1), "( " + oprHeld$(held& - 1) + " ), " + oprTxt$)
          Case "LNEWFUN"
            Call PeepHole_Fold(opcHeld$(held& - 1), oprTxt$)
       End Select
      End If

    Case "COGISUB", "COGIFUN"

      Call PeepHole_foldArguments(3)

    Case "LCLRSUB", "LSETSUB", "LRETSUB", "LCLRFUN", "LSETFUN", "LNEWFUN"

      Call PeepHole_foldArguments(1)

  End Select

End Sub

Sub PeepHole_FoldRangeIndex()
Dim i&
  If opcHeld$(held& - 1) = "PUSH" Then
    If opcHeld$(held& - 2) = "PUSH" Then
      i& = InStr(oprTxt$, "[..]")
      oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + Right$(oprTxt$, Len(oprTxt$) - i& - 2)
      Call PeepHole_Fold(opcTxt$, oprTxt$)
      oprTxt$ = Left$(oprTxt$, i&) + oprHeld$(held& - 1) + ", " + Right$(oprTxt$, Len(oprTxt$) - i&)
      Call PeepHole_Fold(opcTxt$, oprTxt$)
    End If
  End If
End Sub

Sub PeepHole_FoldOpcode()
Dim i&
Dim opr&

  Select Case opcTxt$

    Case "CALL"

      Call PeepHole_foldArguments

      If opcHeld$(held& - 1) = "FRAME" Then
        Select Case oprHeld$(held& - 1)
          Case "CALL WITH RETURN VALUE":    Call PeepHole_Fold("CALLFUN", oprTxt$)
          Case "CALL WITHOUT RETURN VALUE": Call PeepHole_Fold("CALLSUB", oprTxt$)
          Case "CALL WITH ABORT TRAP":      Call PeepHole_Fold("CALLTRP", oprTxt$)
          Case "CALL IGNORING ABORT TRAP":  Call PeepHole_Fold("CALLIGN", oprTxt$)
        End Select
      End If

     Case "CALLOBJ"

      Call PeepHole_foldArguments

      If opcHeld$(held& - 1) = "FRAME" Then
        Select Case oprHeld$(held& - 1)
          Case "CALL WITH RETURN VALUE":    Call PeepHole_Fold("OBJFUN", oprTxt$)
          Case "CALL WITHOUT RETURN VALUE": Call PeepHole_Fold("OBJSUB", oprTxt$)
          Case "CALL WITH ABORT TRAP":      Call PeepHole_Fold("OBJTRP", oprTxt$)
          Case "CALL IGNORING ABORT TRAP":  Call PeepHole_Fold("OBJIGN", oprTxt$)
        End Select
      End If

    Case "RETVAL", "ABOVAL"

      If opcHeld$(held& - 1) = "PUSH" Then
        Select Case opcTxt$
          Case "RETVAL": opcTxt$ = "RETURN"
          Case "ABOVAL": opcTxt$ = "ABORT"
        End Select
        Call PeepHole_Fold(opcTxt$)
      End If

  End Select
End Sub
Sub PeepHole_FoldSpr()
Dim i&
Dim opr&
  i& = InStr(oprTxt$, "SPR[]")
  If i& > 0 Then
    If opcHeld$(held& - 1) = "PUSH" Then
      If IsLiteral(oprHeld$(held& - 1)) Then
        opr& = Val(Right$(oprHeld$(held& - 1), Len(oprHeld$(held& - 1)) - 1))
        If opr& >= 0 And opr& <= 15 Then
          oprTxt$ = Left$(oprTxt$, i& - 1) + reg_nam$(opr& Or &H10) + Right$(oprTxt$, Len(oprTxt$) - i& - 4)
          Call PeepHole_Fold(opcTxt$, oprTxt$)
        End If
      End If
    End If
  End If
End Sub


Sub PeepHole_Print(ByVal i&)
  orgTxt$ = orgHeld$(i&)
  eepTxt$ = eepHeld$(i&)
  labTxt$ = labHeld$(i&)
  opcTxt$ = opcHeld$(i&)
  oprTxt$ = oprHeld$(i&)
  Call DisAsm_Print(True)
End Sub

Function FNshr&(ByVal n&, ByVal w&)
  If w& < 0 Then
    FNshr& = FNshl&(n&, -w&)
  Else
    While w& > 0
      If (n& And &H80000000) = 0 Then
        Select Case w&
          Case 16:   n& = n& \ 65536: w& = w& - 16
          Case 12:   n& = n& \ 4096:  w& = w& - 12
          Case 9:    n& = n& \ 512:   w& = w& - 9
          Case 8:    n& = n& \ 256:   w& = w& - 8
          Case 4:    n& = n& \ 16:    w& = w& - 4
          Case Else: n& = n& \ 2:     w& = w& - 1
        End Select
      Else
        n& = ((n& And &H7FFFFFFF) \ 2) Or &H40000000
        w& = w& - 1
      End If
    Wend
    FNshr& = n&
  End If
End Function

Function FNshl&(ByVal n&, ByVal w&)
  If w& < 0 Then
    FNshl& = FNshr&(n&, -w&)
  Else
    While w& > 0
      Select Case w&
'        Case 16: n& = (n& And &HFFFF) * 32768: w& = w& - 15
        Case 8:  n& = (n& And &HFFFFFF) * 128: w& = w& - 7
      End Select
      If (n& And &H40000000) = 0 Then
        n& = (n& And &H3FFFFFFF) * 2
      Else
        n& = ((n& And &H3FFFFFFF) * 2) Or &H80000000
      End If
      w& = w& - 1
    Wend
    FNshl& = n&
  End If
End Function

Sub DisAsm_Init()
  Call Spin_Init
  Call Asmb_Init
End Sub

Function FNhex$(ByVal n&, ByVal w&)
  FNhex$ = Right$(String$(w&, "0") + Hex$(n&), w&)
End Function

Function FNnum$(ByVal n&, ByVal w&)
  FNnum$ = Right$(String$(w&, "0") + FNstr$(n&), w&)
End Function

Function FNstr$(ByVal n&)
  FNstr$ = LTrim$(Str$(n&))
End Function



Function Label_Spin$(ByVal pc&)
Dim label$
  If flgShowLabels Then
    label$ = Label_Named$(LABEL_TYPE_SPIN, pc&)
  Else
    label$ = Label_Default$(LABEL_TYPE_SPIN, pc&)
  End If
  Label_Spin$ = label$
End Function
Function Label_Var$(ByVal oprTxt$, ByVal varTyp&, varAdr&)
Dim label$
Dim pc&
Dim labelNumber&
Dim offset&

  offset& = 0

  If varTyp& <> VARTYPE_LOC& Then

    Select Case varTyp&
      Case VARTYPE_MEM&:  pc& = varAdr&
      Case VARTYPE_OBJ&:  pc& = varAdr& + oBase&
      Case VARTYPE_VAR&:  pc& = varAdr& + vBase&
    End Select

    '' // we should do this a few times so we can create label + n

    If pc& > 0 And pc& <= MAX_EEPROM& Then
      labelNumber& = labels&(pc&) And &H7FFFFFFF
      If labelNumber& = 0 Then
        pc& = -1
      Else
        label$ = Chr$(FNshr&(labelNumber&, 16)) + FNstr$(labelNumber& And &HFFFF&)
      End If
    End If

  Else

    pc& = varAdr&
    If stack&(pc&) = 0 Then
      pc& = -1
    Else
      label$ = "VL" + FNstr$(stack&(pc&))
      pc& = 16
    End If

  End If

  If pc& > 15 Then
    label$ = Left$(oprTxt$, Len(oprTxt$) - 4) + label$
    If offset& <> 0 Then
      label$ = label$ + FNsigned(offset&)
    End If
  Else
    label$ = oprTxt$ + FNstr$(varAdr&)
  End If

  Label_Var$ = label$
End Function
Function Label_Call$(ByVal pc&, ByVal offset&)
Dim label$
  pc& = pc& + offset&
  If flgShowLabels Then
    label$ = Label_Named$(LABEL_TYPE_CALL, pc&, offset&)
  Else
    label$ = Label_Default$(LABEL_TYPE_CALL, pc&, offset&)
  End If
  Label_Call$ = label$
End Function
Function Label_Asmb$(ByVal pc&, ByVal offset&)
Dim label$
  pc& = pc& + (offset& * 4)
  If flgShowLabels Then
    If varsUsed&(pc&) <> 0 Or stack&(pc&) = 0 Then
      label$ = Label_Named$(LABEL_TYPE_ASMB, pc&, offset&)
    Else
      If stack&(pc&) = 0 Then
        label$ = Label_Named$(LABEL_TYPE_ASMB, pc&, offset&)
      Else
        label$ = "V" + FNstr$(stack&(pc&))
      End If
    End If
  Else
    label$ = Label_Default$(LABEL_TYPE_ASMB, pc&, offset&)
  End If
  Label_Asmb$ = label$
End Function
Function Label_Default$(ByVal typ&, ByVal pc&, Optional ByVal offset&)

  Select Case typ&
    Case LABEL_TYPE_ASMB: Label_Default$ = "$" + FNhex$(offset&, 3)
    Case LABEL_TYPE_LINK: Label_Default$ = "$" + FNhex$(pc&, 4)
    Case LABEL_TYPE_CALL: Label_Default$ = FNsigned$(offset&)
''    Case LABEL_TYPE_MEMV: Label_Default$ = "MEM" + FNsigned$(offset&)
''    Case LABEL_TYPE_VARV: Label_Default$ = "VAR" + FNsigned$(offset&)
''    Case LABEL_TYPE_OBJV: Label_Default$ = "OBJ" + FNsigned$(offset&)
''    Case LABEL_TYPE_LOCV: Label_Default$ = "LOC" + FNsigned$(offset&)
    Case Else:            Label_Default$ = "$" + FNhex$(pc&, 4)
  End Select

End Function

Function Label_Named$(ByVal typ&, ByVal pc&, Optional ByVal offset&)
Dim labelNumber&
Dim label$
  If pc& < 0 Then
    label$ = "******"
  Else
    If pc& > MAX_EEPROM& Then
      label$ = Label_Default$(typ&, pc&, offset&)
    Else
      labelNumber& = labels&(pc&)
      If labelNumber& = 0 Then
        label$ = Label_Default$(typ&, pc&, offset&)
      Else
        If (labelNumber& And &H80000000) <> 0 Then
          label$ = Label_Named$(typ&, labelNumber& And &HFFFF&) + "_ret"
        Else
          label$ = label$ + Chr$(FNshr&(labelNumber&, 16)) + FNstr$(labelNumber& And &HFFFF&)
          If (eeprom&(pc&) And MARK_ARET) <> 0 Then
            label$ = label$ + "_ret"
          End If
        End If
      End If
    End If
  End If
  Label_Named$ = label$
End Function

Function GetWord&()
Dim w&
  w& = GetByte&
  w& = w& Or FNshl&(GetByte&, 8)
  GetWord& = w&
End Function

Function GetLong&()
Dim l&
  l& = GetByte&
  l& = l& Or FNshl&(GetByte&, 8)
  l& = l& Or FNshl&(GetByte&, 16)
  GetLong& = l&
End Function

Function GetQuad&()
Dim q&
  q& = GetByte&
  q& = q& Or FNshl&(GetByte&, 8)
  q& = q& Or FNshl&(GetByte&, 16)
  q& = q& Or FNshl&(GetByte&, 24)
  GetQuad& = q&
End Function


Sub DisAsm_VerifyAssemble()
Dim listfile$

  flgIncludeSourceCode = False
  flgShowImage = False
  flgProcessAssembler = parent.mnuView_ProcessAssembler.Checked
  flgShowLabels = parent.mnuView_ShowLabels.Checked
  flgFoldOpcodes = parent.mnuView_FoldOpcodes.Checked
  flgFoldEffects = parent.mnuView_FoldEffects.Checked
  flgFoldOperators = parent.mnuView_FoldOperators.Checked
  flgFoldArguments = parent.mnuView_FoldArguments.Checked
  flgFoldSpr = parent.mnuView_FoldSpr.Checked
  flgFoldIndexes = parent.mnuView_FoldIndexes.Checked
  flgNoDefaultLong = Not parent.mnuView_DefaultLongVariables.Checked
  flgCastVariables = parent.mnuView_CastVariables.Checked
  flgSymbolTable = False
  flgColonsAfterlabels = parent.mnuView_ColonsAfterLabels.Checked
  flgForceHash = parent.mnuView_ForceHash.Checked

  flgDebugSpin = False
  flgDebugAsmb = False
  flgDebug = False
  flgDebugVars = False

  Call SourceCode_Init

  lastPc& = MAX_EEPROM&
  Call DisAsm_Traverse

  listfile$ = GetTempFile$
  Call DisAsm_Generate(lastFile$, listfile$, False)

  parent.txtDisplay.LoadFile listfile$

  Kill listfile$

End Sub
Sub DisAsm_Decompile(ByVal filename$, Optional ByVal autoReloaded As Boolean)
Dim listfile$
'Dim c$
'Dim labTmp$

  lastFile$ = filename$
  If parent.mnuFile_AutoReload.Checked Then
    parent.ReloadTimer.Enabled = False
    SetAttr filename$, (GetAttr(filename$) And (Not 32))
    parent.ReloadTimer.Enabled = True
  End If
  parent.Caption = App.FileDescription + " - " + ExtractFileBase$(filename$)
  frmPropLoad.StatusBar.Panels(1).Text = filename$

  flgIncludeSourceCode = parent.mnuView_IncludeSourceCode.Checked
  flgShowImage = parent.mnuView_ShowImage.Checked
  flgProcessAssembler = parent.mnuView_ProcessAssembler.Checked
  flgShowLabels = parent.mnuView_ShowLabels.Checked
  flgFoldOpcodes = parent.mnuView_FoldOpcodes.Checked
  flgFoldEffects = parent.mnuView_FoldEffects.Checked
  flgFoldOperators = parent.mnuView_FoldOperators.Checked
  flgFoldArguments = parent.mnuView_FoldArguments.Checked
  flgFoldSpr = parent.mnuView_FoldSpr.Checked
  flgFoldIndexes = parent.mnuView_FoldIndexes.Checked
  flgNoDefaultLong = Not parent.mnuView_DefaultLongVariables.Checked
  flgCastVariables = parent.mnuView_CastVariables.Checked
  flgSymbolTable = parent.mnuView_SymbolTable.Checked
  flgColonsAfterlabels = parent.mnuView_ColonsAfterLabels.Checked
  flgForceHash = parent.mnuView_ForceHash.Checked

  flgDebugSpin = parent.mnuHelp_DebugSpin.Checked
  flgDebugAsmb = parent.mnuHelp_DebugAsmb.Checked
  flgDebug = flgDebugSpin Or flgDebugAsmb
  flgDebugVars = parent.mnuHelp_DebugVars.Checked And flgDebug

  parent.txtDisplay.Text = ""

  Call SourceCode_Init

  parent.MousePointer = 11
  DoEvents

  Call DisAsm_LoadImageFile

  If Not DisAsm_ChecksumOkay Then
    parent.MousePointer = 0
    Exit Sub
  End If

  lastPc& = MAX_EEPROM&
  Call DisAsm_Traverse

  listfile$ = GetTempFile$
  Call DisAsm_Generate(filename$, listfile$, autoReloaded)

  parent.txtDisplay.LoadFile listfile$

  Kill listfile$

  With parent
    .mnuFile_Save.Enabled = True
    .mnuFile_SaveAs.Enabled = True
    .mnuFile_Print.Enabled = True
    .mnuFile_PrintWithSource.Enabled = True
''    .mnuPort_Run.Enabled = True
''    .mnuPort_Download(0).Enabled = True
''    .mnuPort_Download(1).Enabled = True
    .mnuEdit_Copy.Enabled = True
    .mnuEdit_SelectAll.Enabled = True
''    .mnuEdit_SelectLines.Enabled = True
    .mnuEdit_Find.Enabled = True
    .mnuEdit_FindNext.Enabled = True
  End With

  Call Toolbar_Enable("SAVE", True)
  Call Toolbar_Enable("PRINT", True)
  Call Toolbar_Enable("COPY", True)
  Call Toolbar_Enable("FIND", True)
''  Call Toolbar_Enable("DOWNLOAD", True)

  Call Mru_Add(filename$)

  If frmDbugInfoLoaded Then
    frmDbugInfo.txtDisplay.SelStart = 0
    LockWindowUpdate 0
  End If

  parent.MousePointer = 0

End Sub

Sub Toolbar_Enable(ByVal nam$, ByVal isEnabled As Boolean)
Dim i&
  With parent.Toolbar.Buttons
    For i& = 1 To .count
      If UCase$(.Item(i&).ToolTipText) = nam$ Then
        .Item(i&).Enabled = isEnabled
      End If
    Next
  End With
End Sub

Sub Asmb_Found_Org0(ByVal here&)
Dim i&

  If flgProcessAssembler Then

    ' we need to clear the done flag because having pushed the address of the
    ' assembler code to the stack, it will have been marked as a done variable
    ' and thus we won't parse the actual assembler. Clearing done doesn't have
    ' too much of a penalty because we'll abort on the second instruction that
    ' is done if we've already traversed this code before.
    
  If here& > MAX_EEPROM& Then
    Exit Sub
  End If
    
    eeprom&(here&) = eeprom&(here&) And (Not MARK_DONE)

    Call Asmb_Found(here&, MARK_ORG0 Or MARK_CALL)

  End If

End Sub

Sub Data_Decode()
Dim txt$

  If (eeprom&(pc&) And MARK_PADS) <> 0 Then
    Call DisAsm_Mode(MODE_PADS)
    txt$ = "Alignment Padding"
  Else
    If (eeprom&(pc&) And MARK_LINK) <> 0 Then
      Call DisAsm_Mode(MODE_LINK)
    Else
      Call DisAsm_Mode(MODE_DATA)
    End If
    txt$ = ""
  End If

  If (eeprom&(pc&) And MARK_LINK) <> 0 Then
    txt$ = FNsigned$((pc& - oBase&) \ 4)
    If ((pc& - oBase&) \ 4) = 0 Then
      txt$ = txt$ + " = Next Object_"
    End If
    Call DisAsm_Info("LINK     x", txt$)
  Else
    If (eeprom&(pc&) And MARK_LONG) <> 0 Then
      Call DisAsm_Info("LONG     k4", txt$)
      Call Data_Decode_Equs(pc&, 4, MARK_WORD, "W", "HML")
      Call Data_Decode_Equs(pc&, 4, MARK_BYTE, "B", "0123")
    Else
      If (eeprom&(pc&) And MARK_WORD) <> 0 Then
        Call DisAsm_Info("WORD     k2", txt$)
        Call Data_Decode_Equs(pc&, 2, MARK_BYTE, "B", "HL")
      Else
        If (eeprom&(pc&) And MARK_ARAY) <> 0 And _
           (eeprom&(pc&) And &HFF) <> 0 _
        Then
          Call DisAsm_Info("BYTE     kc", txt$)
        Else
          Call DisAsm_Info("BYTE     k1", txt$)
        End If
      End If
    End If
  End If
End Sub

Sub DisAsm_Align(ByVal pc&)
Dim flag$

  If pc& > MAX_EEPROM& Then
    Exit Sub
  End If
  
  If (eeprom&(pc& - 1) And MARK_LONG) <> 0 Then ' ---* ***
    Exit Sub
  End If
  If (eeprom&(pc& - 1) And MARK_WORD) <> 0 Then ' ---* *
    Exit Sub
  End If
  If (eeprom&(pc& - 1) And MARK_BYTE) <> 0 Then ' ---*
    Exit Sub
  End If

  flag$ = "----"

  If (eeprom&(pc& - 2) And MARK_LONG) <> 0 Then ' --** **
    Exit Sub
  End If
  If (eeprom&(pc& - 2) And MARK_WORD) <> 0 Then ' --**
    Exit Sub
  End If
  If (eeprom&(pc& - 2) And MARK_BYTE) <> 0 Then ' --*-
    Mid$(flag$, 3) = "*"
  End If

  If (eeprom&(pc& - 3) And MARK_LONG) <> 0 Then ' -*** *
    Exit Sub
  End If
  If (eeprom&(pc& - 3) And MARK_WORD) <> 0 Then ' -**-
    Mid$(flag$, 2) = "**"
  End If
  If (eeprom&(pc& - 3) And MARK_BYTE) <> 0 Then ' -*--
    Mid$(flag$, 2) = "*"
  End If

  If (eeprom&(pc& - 4) And MARK_LONG) <> 0 Then ' ****
    Exit Sub
  End If
  If (eeprom&(pc& - 4) And MARK_WORD) <> 0 Then ' **--
    Mid$(flag$, 1) = "**"
  End If
  If (eeprom&(pc& - 4) And MARK_BYTE) <> 0 Then ' *---
    Mid$(flag$, 1) = "*"
  End If

  If (eeprom&(pc& - 4) And (MARK_DONE Or MARK_SPIN Or MARK_ASMB)) <> 0 Then ' *---
    Mid$(flag$, 1) = "*"
  End If
  If (eeprom&(pc& - 3) And (MARK_DONE Or MARK_SPIN Or MARK_ASMB)) <> 0 Then ' -*--
    Mid$(flag$, 2) = "*"
  End If
  If (eeprom&(pc& - 2) And (MARK_DONE Or MARK_SPIN Or MARK_ASMB)) <> 0 Then ' --*-
    Mid$(flag$, 3) = "*"
  End If
  If (eeprom&(pc& - 1) And (MARK_DONE Or MARK_SPIN Or MARK_ASMB)) <> 0 Then ' ---*
    Mid$(flag$, 4) = "*"
  End If

  Select Case Right$(flag$, 3)
    Case "---"
      Call Mark(pc& - 3, MARK_WORD Or MARK_PADS)
      Call Mark(pc& - 1, MARK_BYTE Or MARK_PADS)
    Case "*--"
      Call Mark(pc& - 2, MARK_WORD Or MARK_PADS)
    Case "**-", "-*-"
      Call Mark(pc& - 1, MARK_BYTE Or MARK_PADS)
  End Select

End Sub

Function DisAsm_ChecksumOkay() As Boolean
Dim hash&
  hash& = DisAsm_CalculateChecksum&
  If hash& <> 0 Then
    Call DisAsm_ChecksumFix(sBase& - 8, &HFF)
    Call DisAsm_ChecksumFix(sBase& - 7, &HFF)
    Call DisAsm_ChecksumFix(sBase& - 6, &HF9)
    Call DisAsm_ChecksumFix(sBase& - 5, &HFF)
    Call DisAsm_ChecksumFix(sBase& - 4, &HFF)
    Call DisAsm_ChecksumFix(sBase& - 3, &HFF)
    Call DisAsm_ChecksumFix(sBase& - 2, &HF9)
    Call DisAsm_ChecksumFix(sBase& - 1, &HFF)
    hash& = DisAsm_CalculateChecksum&
  End If
  If hash& = 0 Then
    DisAsm_ChecksumOkay = True
  Else
    If frmPropLoad.mnuFile_InhibitWarnings.Checked Then
      DisAsm_ChecksumOkay = True
    Else
      DisAsm_ChecksumOkay = MsgBox(lastFile$ + vbCrLf + vbCrLf + "The file checksum is not as expected." + vbCrLf + vbCrLf + "Do you want to try and decompile the image ?", vbCritical + vbYesNo, App.FileDescription) = vbYes
    End If
  End If
End Function
Sub DisAsm_DumpSymbolTable()
Dim o$
Dim Mark&
Dim count&

  oBase& = pBase&
  vBase& = vMain&

  Print #2, ""
  Print #2, "Symbol Table"
  Print #2, "============"
  Print #2, ""

  count& = 5
  For pc& = 0 To MAX_EEPROM&
    If labels&(pc&) <> 0 Then
      count& = count& + 1
    End If
  Next

  Print #2, FNplural$(count&, "symbol") + " used"
  Print #2, ""

  If labelTypeList$ <> "" Then
    If InStr(labelTypeList$, "A") <> 0 Then Print #2, "A = Assembler Jump Destination"
    If InStr(labelTypeList$, "B") <> 0 Then Print #2, "B = Byte Variable"
    If InStr(labelTypeList$, "F") <> 0 Then Print #2, "F = Function Entry Point"
    If InStr(labelTypeList$, "J") <> 0 Then Print #2, "J = Jump Destination"
    If InStr(labelTypeList$, "L") <> 0 Then Print #2, "L = Long Variable"
    If InStr(labelTypeList$, "N") <> 0 Then Print #2, "N = Jump if False ( Not True ) Destination"
    If InStr(labelTypeList$, "O") <> 0 Then Print #2, "O = Object"
    If InStr(labelTypeList$, "R") <> 0 Then Print #2, "R = Assembler RET Location"
    If InStr(labelTypeList$, "S") <> 0 Then Print #2, "S = Subroutine Entry Point"
    If InStr(labelTypeList$, "T") <> 0 Then Print #2, "T = Jump if True Destination"
    If InStr(labelTypeList$, "V") <> 0 Then Print #2, "V = Assembler Variable"
    If InStr(labelTypeList$, "W") <> 0 Then Print #2, "W = Word Variable"
    If InStr(labelTypeList$, "X") <> 0 Then Print #2, "X = Link Vector"
    Print #2, ""
  End If

  Print #2, FNhex$(pBase&, 4) + "   PBASE    Base of Program"
  Print #2, FNhex$(vMain&, 4) + "   VBASE    Base of Variables"
  Print #2, FNhex$(sBase&, 4) + "   SBASE    Base of Stack"
  Print #2, FNhex$(pInit&, 4) + "   PINIT    Initial Program Counter"
  Print #2, FNhex$(sInit&, 4) + "   SINIT    Initial Stack Pointer"
  Print #2, ""

  For pc& = 0 To lastPc&
    If labels&(pc&) <> 0 Then
      o$ = FNhex$(pc&, 4) + "   " + Label_Named$(LABEL_TYPE_SPIN, pc&)
      Mark& = eeprom&(pc&) And &HFFFFFF00
      If (Mark& And MARK_XOBJ&) <> 0 Then
        oBase& = pc&
      End If
      If Mark& <> 0 Then
        o$ = FNpad$(o$, 15)
        If (Mark& And MARK_LINK&) <> 0 Then o$ = o$ + " Link   " + Label_Named$(LABEL_TYPE_SPIN, PeekLink&((pc& - oBase&) \ 4))
        If (Mark& And MARK_SPIN&) <> 0 Then o$ = o$ + " Spin "
        If (Mark& And MARK_ASMB&) <> 0 Then o$ = o$ + " Asmb "
        If (Mark& And MARK_ORG0&) <> 0 Then o$ = o$ + "  Org0"
        If (Mark& And MARK_PADS&) <> 0 Then o$ = o$ + "  Pads"
        If (Mark& And MARK_CALL&) <> 0 Then o$ = o$ + "  Call"
        If (Mark& And MARK_GOTO&) = MARK_GOTO& Then
          o$ = o$ + "  Goto"
        Else
          If (Mark& And MARK_JMPT&) <> 0 Then o$ = o$ + "  JmpT"
          If (Mark& And MARK_JMPF&) <> 0 Then o$ = o$ + "  JmpF"
        End If
        If (Mark& And (MARK_LONG& Or MARK_WORD& Or MARK_BYTE&)) <> 0 Then
          If (Mark& And (MARK_LINK& Or MARK_SPIN& Or MARK_ASMB&)) <> 0 Then
            o$ = o$ + " "
          End If
          If (Mark& And MARK_LONG&) <> 0 Then o$ = o$ + " Long"
          If (Mark& And MARK_WORD&) <> 0 Then o$ = o$ + " Word"
          If (Mark& And MARK_BYTE&) <> 0 Then o$ = o$ + " Byte"
        End If
      End If

      If flgDebugAsmb Then
        If (Mark& And MARK_ARET&) <> 0 Then o$ = o$ + "  ARet"
      End If
      If callFrom&(pc&) Or callPair&(pc&) Then
        o$ = FNpad$(o$, 40)
        If callFrom&(pc&) Then
          If (eeprom&(pc&) And MARK_CALL) <> 0 Then
            o$ = o$ + "  Called"
          Else
            o$ = o$ + "  Jumped"
          End If
          o$ = o$ + " from " + FNhex$(callFrom&(pc&), 4)
        End If
        If callPair&(pc&) Then
          o$ = o$ + "  Paired with " + FNhex$(callPair&(pc&), 4) + " = " + Label_Named$(LABEL_TYPE_ASMB, callPair&(pc&))
        End If
      End If

      Print #2, RTrim$(o$)

    End If
  Next

  oBase& = pBase&
  vBase& = vMain&

End Sub

Sub Data_Describe_Equ(ByVal pc&, ByVal offset&, ByVal c$, ByVal postfix$)
  orgTxt$ = FNhex$(pc& + offset&, 4)
  eepTxt$ = ""
  opcTxt$ = "EQU"
  oprTxt$ = Label_Spin$(pc&) '"?" + FNhex$(pc&, 4)
  labTxt$ = oprTxt$
  oprTxt$ = oprTxt$ + FNsigned$(offset&)
  Mid$(labTxt$, 1) = c$
  labTxt$ = labTxt$ + "_" + postfix$
  Call DisAsm_Print
End Sub

Sub DisAsm_Info(ByVal l$, Optional ByVal comment$)
  orgTxt$ = FNhex$(pc&, 4)
  eepTxt$ = ""
  opcTxt$ = ""
  oprTxt$ = ""
  Call Mark(pc&, MARK_DONE)
  Call Spin_Describe(pc&, l$)
  If comment$ <> "" Then
    oprTxt$ = FNpad(oprTxt$, PAD_COMMENT) + "; " + comment$
  End If
  Call DisAsm_Print
End Sub
Sub DisAsm_InsertLabel(ByVal lab$, Optional ByVal opc$, Optional ByVal opr$)
Dim labPush$
  Call Asmb_Finalise
  labPush$ = labTxt$
  If lab$ <> "" Then
    orgTxt$ = "_" + FNhex$(pc&, 4)
    labTxt$ = lab$
    If flgColonsAfterlabels Then
      labTxt$ = labTxt$ + ":"
    End If
  Else
    orgTxt$ = "_"
    labTxt$ = ""
  End If
  eepTxt$ = ""
  opcTxt$ = opc$
  If Len(opr$) <> 0 Then
    opcTxt$ = FNpad$(opcTxt$, PAD_OPR) + opr$
  End If
  oprTxt$ = "_"
  Call DisAsm_Print
  labTxt$ = labPush$
End Sub

Sub DisAsm_LoadImageFile()
  #If False Then
'
'  Dim s&
'  Dim c$
'
'    Erase eeprom&()
'    Erase labels&()
'    Erase callPair&()
'    Erase callFrom&()
'    Erase varsUsed&()
'
'    pc& = 0
'    held& = 0
'    org& = 0
'    asmbMarker& = 0
'    createListing = False
'
'    s& = FreeFile
'    c$ = Chr$(0)
'    Open lastFile$ For Binary As #s&
'    While pc& < LOF(s&)
'      Get #s&, , c$
'      eeprom&(pc&) = Asc(c$)
'      pc& = pc& + 1
'    Wend
'    Close #s&
'
  #Else

  Dim s&
  Dim n&

    Erase eeprom&()
    Erase labels&()
    Erase callPair&()
    Erase callFrom&()
    Erase varsUsed&()

    pc& = 0
    held& = 0
    org& = 0
    asmbMarker& = 0
    createListing = False

    s& = FreeFile
    Open lastFile$ For Binary As #s&
    Get #s&, , labels&()
    For pc& = 0 To LOF(s&) - 1 Step 4
      n& = labels&(pc& \ 4)
      eeprom&(pc& + 0) = n& And &HFF
      eeprom&(pc& + 1) = FNshr&(n&, 8) And &HFF
      eeprom&(pc& + 2) = FNshr&(n&, 16) And &HFF
      eeprom&(pc& + 3) = FNshr&(n&, 24) And &HFF
    Next
    Close #s&

    Erase labels&()

  #End If

End Sub

Sub DisAsm_Mode(ByVal newMode&)
  If mode& <> newMode& Then
    mode& = newMode&
    Call Disasm_ForceBlankLine
  End If
End Sub
Sub Disasm_SetLabels()
Dim b&
Dim c$

  stackLabelNumber& = 0
  asmbLabelNumber& = 0

  labelTypeList$ = ""
  b& = 0
  For pc& = 0 To lastPc&
    If labels&(pc) = 0 Then
      If (eeprom&(pc&) And MARK_JMPS) <> 0 Then
        If (eeprom&(pc&) And MARK_ASMB) <> 0 Then
          c$ = "A"
        Else
          If (eeprom&(pc&) And MARK_CALL) <> 0 Then
            If (eeprom&(pc&) And MARK_XFUN) <> 0 Then
              c$ = "F"
            Else
              c$ = "S"
            End If
          Else
            If (eeprom&(pc&) And MARK_JMPT) <> 0 Then
              If (eeprom&(pc&) And MARK_JMPF) <> 0 Then
                c$ = "J"
              Else
                c$ = "T"
              End If
            Else
              If (eeprom&(pc&) And MARK_JMPF) <> 0 Then
                c$ = "N"
              Else
                c$ = "J"
              End If
            End If
          End If
        End If
        b& = b& + 1
        Call Disasm_SetlabelThis(pc&, c$, b&)
      Else
        If (eeprom&(pc&) And MARK_PADS) = 0 Then
          If (eeprom&(pc&) And MARK_VARS) <> 0 Then
            If (eeprom&(pc&) And MARK_ARAY) = 0 Or (eeprom&(pc&) And MARK_DONE) <> 0 Then
              If (eeprom&(pc&) And MARK_LINK) <> 0 Then
                If (eeprom&(pc&) And MARK_XOBJ) <> 0 Then
                  c$ = "O"
                Else
                  c$ = "X"
                End If
              Else
                If (eeprom&(pc&) And MARK_LONG) <> 0 Then
                  c$ = "L"
                Else
                  If (eeprom&(pc&) And MARK_WORD) <> 0 Then
                    c$ = "W"
                  Else
                    c$ = "B"
                  End If
                End If
              End If
              b& = b& + 1
              Call Disasm_SetlabelThis(pc&, c$, b&)
            End If
          End If
        End If
      End If
    Else
      If labels(pc&) = &H80000000 Then
        b& = b& + 1
        Call Disasm_SetlabelThis(pc&, "R", b&)
      End If
    End If
  Next

End Sub
Sub Disasm_SetlabelThis(ByVal pc&, ByVal c$, ByVal b&)
  labels&(pc&) = (Asc(c$) * 65536) Or b&
  If InStr(labelTypeList$, c$) = 0 Then
    labelTypeList$ = labelTypeList$ + c$
  End If
End Sub
Function FNbin$(ByVal n&, w&)
Dim o$
  While w& > 0
    If (n& And 1) <> 0 Then
      o$ = "1" + o$
    Else
      o$ = "0" + o$
    End If
    n& = FNshr&(n&, 1)
    w& = w& - 1
  Wend
  FNbin$ = o$
End Function

Function FNpad$(ByVal o$, ByVal w&)
Dim l&
  l& = Len(o$)
  If l& < w& Then
    FNpad$ = o$ + Space$(w& - l&)
  Else
    FNpad$ = o$ + " "
  End If
End Function


Function FNsigned$(ByVal n&)
  If n& < 0 Then
    FNsigned$ = FNstr$(n&)
  Else
    FNsigned$ = "+" + FNstr$(n&)
  End If
End Function

Function PeekLink&(ByVal offset&)
  PeekLink& = oBase& + PeekWord&(oBase& + (offset& * 4))
End Function
Function PeekLinkSize&(ByVal offset&)
  PeekLinkSize& = PeekWord&(oBase& + (offset& * 4) + 2)
End Function


Sub DisAsm_ReLoad()
  If FNexists(lastFile$) Then
    If frmDbugInfoLoaded Then
      frmDbugInfo.txtDisplay = ""
      LockWindowUpdate frmDbugInfo.txtDisplay.hWnd
    End If
    Call DisAsm_Decompile(lastFile$)
  Else
    MsgBox "Cannot find " + lastFile$, vbExclamation, App.FileDescription
  End If
End Sub
Sub DisAsm_Print(Optional ByVal emit As Boolean)
Dim o$
Dim indentPostInc&
Dim TABBED&
Dim eepExtra$
Dim i&
Const EEPEXTRA_SPLIT& = 15

  If emit Then

    If opcTxt$ = "_" Then

      If Not hadCrLf Then
        Print #2, ""
        hadCrLf = True
      End If

    Else

      If Left$(orgTxt$, 1) = "_" Then
        If Not hadCrLf Then
          Print #2, ""
          hadCrLf = True
        End If
        o$ = Right$(orgTxt$, Len(orgTxt$) - 1)
      Else
        o$ = orgTxt$
      End If
      eepExtra$ = ""
      If flgShowImage Then
        If Len(eepTxt$) <> 0 Then
          If Len(eepTxt$) > EEPEXTRA_SPLIT& Then
            eepExtra$ = Right$(eepTxt$, Len(eepTxt$) - EEPEXTRA_SPLIT&)
            eepTxt$ = Left$(eepTxt$, EEPEXTRA_SPLIT&)
            eepExtra$ = FNhex$(Val("&h" + Left$(orgTxt$, 4)) + 5, 4) + "          + " + eepExtra$
          End If
          o$ = FNpad$(o$, PAD_EEPROM) + eepTxt$
        End If
        If Len(labTxt$) <> 0 Then
          o$ = FNpad$(o$, PAD_LABEL) + labTxt$
        End If
        TABBED& = 0
      Else
        o$ = labTxt$
        TABBED& = -29
      End If
      Select Case Right$(oprTxt$, 1)
        Case ">": oprTxt$ = Left$(oprTxt$, Len(oprTxt$) - 1)
                  indentPostInc& = 2
        Case "<": oprTxt$ = Left$(oprTxt$, Len(oprTxt$) - 1)
                  indent& = indent& - 2
                  If indent& < 0 Then
                    indent& = 0
                  End If
      End Select

      If Len(oprTxt$) <> 0 Then
        If Len(opcTxt$) = 0 Then
          opcTxt$ = oprTxt$
        Else
          opcTxt$ = FNpad$(opcTxt$, PAD_OPR) + oprTxt$
        End If
      End If

      If Len(opcTxt$) <> 0 Then
        If Len(o$) > (PAD_OPC + TABBED& + indent&) Then
          i& = Len(o$) - (PAD_OPC + TABBED& + indent&)
          If Left$(opcTxt$, i&) = Space$(i&) Then
            opcTxt$ = Space$(PAD_OPC + TABBED + indent&) + opcTxt$
            Mid$(opcTxt$, 1) = o$
            o$ = opcTxt$
          Else
            o$ = FNpad$(o$, PAD_OPC + TABBED& + indent&) + "[2]" + opcTxt$
          End If
        Else
          o$ = FNpad$(o$, PAD_OPC + TABBED& + indent&) + opcTxt$
        End If
      End If

      If Right$(o$, 1) = "_" Then
        o$ = Left$(o$, Len(o$) - 1)
        Print #2, o$
        Print #2, ""
        hadCrLf = True
      Else
        Print #2, o$
        hadCrLf = False
      End If
      indent& = indent& + indentPostInc&
      indentPostInc& = 0

      If Len(eepExtra$) <> 0 Then
        While Len(eepExtra$) > EEPEXTRA_SPLIT& + 12
          Print #2, Left$(eepExtra$, EEPEXTRA_SPLIT& + 12)
          eepExtra$ = FNhex$(Val("&h" + Left$(eepExtra$, 4)) + 4, 4) + "          +" + Right$(eepExtra$, Len(eepExtra$) - (EEPEXTRA_SPLIT& + 12))
        Wend
        Print #2, eepExtra$
      End If

    End If

  Else
    Call PeepHole_Add
  End If
End Sub
Function Version_KnownBug$(ByVal separator$)
Dim o$
  o$ = ""

  o$ = o$ + vbCrLf + separator$ + "Incomplete 'Using' effects decoding"

  Version_KnownBug$ = o$
End Function

Function Version_Info$()
Dim o$

  o$ = App.ProductName + " - " + Version$

  o$ = o$ + vbCrLf + vbCrLf + "New in this version ..." + vbCrLf
  o$ = o$ + vbCrLf + "    * Option to inhibit warning messages"

  o$ = o$ + vbCrLf + vbCrLf + "Recent Additions ..." + vbCrLf
  o$ = o$ + vbCrLf + "    * Better Assembler parsing"
  o$ = o$ + vbCrLf + "    * In-line source code inclusion"
  o$ = o$ + vbCrLf + "    * Variable naming implemented"
  o$ = o$ + vbCrLf + "    * Objects supported"

  If Version_KnownBug$("") <> "" Then
    o$ = o$ + vbCrLf + vbCrLf + "Known Bugs ..." + vbCrLf + Version_KnownBug$("    * ")
  End If

  Version_Info$ = o$

End Function


