Attribute VB_Name = "basSupport"
Option Explicit
Global appPath$
Global appName$

Global appId$

Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type

'API Calls:
Private Declare Function GetVersionEx _
  Lib "kernel32.dll" _
  Alias "GetVersionExA" _
  ( _
    lpVersionInformation As OSVERSIONINFO _
  ) As Long

'API Constants
Const VER_PLATFORM_WIN32_WINDOWS = 1
Const VER_PLATFORM_WIN32_NT = 2

Private Declare Function IsThemeActive Lib "uxtheme.dll" () As Long
Private Declare Function IsAppThemed Lib "uxtheme.dll" () As Long

Private Type tagInitCommonControlsEx
  lngSize As Long
  lngICC As Long
End Type

Private Declare Function InitCommonControlsEx _
  Lib "comctl32.dll" _
  ( _
    iccex As tagInitCommonControlsEx _
  ) As Boolean

Const ICC_USEREX_CLASSES = &H200

Private Declare _
  Function GetTempFileName _
  Lib "Kernel32" _
  Alias "GetTempFileNameA" _
  ( _
    ByVal lpszPath As String, _
    ByVal lpPrefixString As String, _
    ByVal wUnique As Long, _
    ByVal lpTempFileName As String _
  ) As Long

Private Declare _
  Function GetTempPath _
  Lib "Kernel32" _
  Alias "GetTempPathA" _
  ( _
    ByVal _
    nBufferLength As Long, _
    ByVal lpBuffer As String _
  ) As Long

Private Declare _
  Function FindWindow _
  Lib "user32" _
  Alias "FindWindowA" _
  ( _
    ByVal lpClassName As String, _
    ByVal lpWindowName As String _
  ) As Long



Function IsoDateAndTime$()
Dim d$
Dim t$
  d$ = Date$
  t$ = Time$
  While d$ <> Date$
    d$ = Date$
    t$ = Time$
  Wend
  IsoDateAndTime$ = Right$(d$, 4) + "-" + Left$(d$, 5) + " " + t$
End Function
Function IsoDate$()
Dim d$
  d$ = Date$
  IsoDate$ = Right$(d$, 4) + "-" + Left$(d$, 5)
End Function
 Function RunningInIde() As Boolean
  On Error GoTo IDEInUse
  Debug.Print 1 \ 0
  RunningInIde = False
  Exit Function
IDEInUse:
  RunningInIde = True
End Function
Function ExtractFileName$(ByVal f$)
  f$ = Right$(f$, Len(f$) - Len(ExtractFilePath$(f$)))
  If Left$(f$, 1) = "\" Then
    f$ = Right$(f$, Len(f$) - 1)
  End If
  ExtractFileName$ = f$
End Function

Function ExtractFilePath$(ByVal f$)
Dim i&
  If InStr(f$, "\") <> 0 Then
    i& = Len(f$)
    While Mid$(f$, i&, 1) <> "\"
      i& = i& - 1
    Wend
    f$ = Left$(f$, i& - 1)
  Else
    f$ = ""
  End If
  ExtractFilePath$ = f$
End Function
Function ExtractFileBase$(ByVal f$)
Dim i&
  f$ = ExtractFileName$(f$)
  If InStr(f$, ".") <> 0 Then
    i& = Len(f$)
    While Mid$(f$, i&, 1) <> "."
      i& = i& - 1
    Wend
    f$ = Left$(f$, i& - 1)
  End If
  ExtractFileBase$ = f$
End Function
Function PropellerToolIsOpen() As Boolean
  If FindWindow(vbNullString, "Propeller Tool ") <> 0 Then
    PropellerToolIsOpen = True
  Else
    If FindWindow(vbNullString, "Propeller Tool") <> 0 Then
      PropellerToolIsOpen = True
    Else
      PropellerToolIsOpen = False
    End If
  End If
End Function
Function FNdirMask$(ByVal f$, ByVal m&)
Dim ff$
  ff$ = ""
  If f$ <> "" Then
    On Error Resume Next
    ff$ = Dir$(f$, m&)
  End If
  On Error GoTo 0
  FNdirMask$ = ff$
End Function
Function FNdir$(ByVal f$)
Dim ff$
  ff$ = ""
  If f$ <> "" Then
    On Error Resume Next
    ff$ = Dir$(f$)
  End If
  On Error GoTo 0
  FNdir$ = ff$
End Function

Function FNexists(ByVal f$) As Boolean
  FNexists = FNdir$(f$) <> ""
End Function

Sub Main()
  Call WinXp
  
  If GetSetting("PropLoad", "Setup", "RunOnce") <> "" Then
    appId$ = "PropLoad"
  Else
    appId$ = "Propeller Chip Disassembler"
  End If

  If UCase$(App.EXEName) = "PROPVIEW" Then
    If FNswitch("/DOWNLOAD") Then
      Load frmFastLoad
    Else
      Load frmPropLoad
    End If
  Else
    If FNswitch("/VIEW") Or FNswitch("/VIEWER") Then
      Load frmPropLoad
    Else
      If RunningInIde Then
        Load frmFastLoad
      Else
        MsgBox "Sorry - The Application names have changed." + vbCrLf + vbCrLf + "You should now be running the PropView Application to disassemble Propeller Chip bytecode.", vbInformation, "AiChip Downloader for the Propeller Chip"
      End If
    End If
  End If
End Sub

Function FNswitch(ByVal s$)
Dim found As Boolean
  found = InStr(UCase$(Command$) + " ", s$) <> 0
  If Not found Then
    found = InStr(UCase$(Command$) + "/", s$) <> 0
  End If
  If Not found Then
    found = Right$(UCase$(Command$), Len(s$)) = s$
  End If
  FNswitch = found
End Function


Private Function FNstr$(ByVal n&)
  FNstr$ = LTrim$(Str$(n&))
End Function
Private Function FNnum$(ByVal n&, ByVal w&)
  FNnum$ = Right$(String$(w&, "0") + FNstr$(n&), w&)
End Function
Function GetTempFile$()
Dim TempFile$
Dim TempPath$
    
  TempPath$ = Space$(260)
  GetTempPath Len(TempPath), TempPath
  TempPath = Left$(TempPath, InStr(TempPath & vbNullChar, vbNullChar) - 1)
    
  TempFile$ = Space$(260)
  GetTempFileName TempPath, "PLD", 0, TempFile
  GetTempFile$ = Left$(TempFile, InStr(TempFile & vbNullChar, vbNullChar) - 1)

End Function

Public Sub WinXp(Optional ByVal doNotReLaunch As Boolean)

  appPath$ = App.path
  If Right$(appPath$, 1) <> "\" Then
    appPath$ = appPath$ + "\"
  End If
  appName$ = App.EXEName$
  
  If WinXp_GetOsVersionName$ = "XP" Or WinXp_GetOsVersionName$ = "Vista" Then
    If WinXp_IsThemed Then
      If Not FNexists(appPath$ + appName$ + ".exe.manifest") Then
        If FNexists(appPath$ + appName$ + ".exe") Then
          Call WinXp_CreateManifestFile(appPath$, appName$)
            Shell appPath$ + appName$ + " " + Command$ + " /RELAUNCH:WINXP", vbNormalFocus
            End
        End If
      End If
    End If
    Call WinXp_InitCommonControls
  End If
End Sub
Public Sub WinXp_CreateManifestFile(ByVal appPath$, ByVal appName$)
Dim d&
  d& = FreeFile
  Open appPath$ + appName$ + ".exe.manifest" For Output As #d&
  Print #d&, "<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>"
  Print #d&, "<assembly xmlns=""urn:schemas-microsoft-com:asm.v1"" manifestVersion=""1.0"">"
  Print #d&, "<assemblyIdentity"
  Print #d&, "version=""1.0.0.0"""
  Print #d&, "processorArchitecture=""X86"""
  Print #d&, "name=""Microsoft.VB6.VBnetStyles"""
  Print #d&, "type=""win32"""
  Print #d&, "/>"
  Print #d&, "<description>AiChip Manifest for " + App.FileDescription + "</description>"
  Print #d&, "<dependency>"
  Print #d&, "<dependentAssembly>"
  Print #d&, "<assemblyIdentity"
  Print #d&, "type=""win32"""
  Print #d&, "name=""Microsoft.Windows.Common-Controls"""
  Print #d&, "version=""6.0.0.0"""
  Print #d&, "processorArchitecture=""X86"""
  Print #d&, "publicKeyToken=""6595b64144ccf1df"""
  Print #d&, "language=""*"""
  Print #d&, "/>"
  Print #d&, "</dependentAssembly>"
  Print #d&, "</dependency>"
  Print #d&, "</assembly>"
  Close #d&
End Sub


Private Sub WinXp_InitCommonControls()
Dim iccex As tagInitCommonControlsEx
  On Error Resume Next
  With iccex
    .lngSize = LenB(iccex)
    .lngICC = ICC_USEREX_CLASSES
  End With
  InitCommonControlsEx iccex
  On Error GoTo 0
End Sub

Public Function WinXp_GetOsVersionName$()
Dim udtOSVersion As OSVERSIONINFO
Dim lMajorVersion  As Long
Dim lMinorVersion As Long
Dim lPlatformID As Long
Static result$

  If result$ = "" Then
  
    udtOSVersion.dwOSVersionInfoSize = Len(udtOSVersion)
    GetVersionEx udtOSVersion
    lMajorVersion = udtOSVersion.dwMajorVersion
    lMinorVersion = udtOSVersion.dwMinorVersion
    lPlatformID = udtOSVersion.dwPlatformId
    
    Select Case lMajorVersion
    
      Case 6
      
        result$ = "Vista"
        
      Case 5
      
        Select Case lMinorVersion
          Case 0:    result$ = "2000"
          Case 1:    result$ = "XP"
          Case 2:    result$ = "2003"
          Case Else: result$ = "2000 / XP / 2003"
        End Select
        
      Case 4
        
        If lPlatformID = VER_PLATFORM_WIN32_NT Then
          result$ = "NT 4.0"
        Else
          If lMinorVersion = 0 Then
            result$ = "95"
          Else
            result$ = "98"
          End If
        End If
      
      Case 3
        
        If lPlatformID = VER_PLATFORM_WIN32_NT Then
          result$ = "NT 3.x"
        Else
          result$ = "3.x"
        End If
      
      Case Else
        
        result$ = "Unknown"
        
    End Select
    
  End If
  
  WinXp_GetOsVersionName$ = result$

End Function



Public Function WinXp_IsThemed() As Boolean
Static isCached As Boolean
Static cachedResult As Boolean
  If Not isCached Then
    If WinXp_GetOsVersionName$ = "XP" Or WinXp_GetOsVersionName$ = "Vista" Then
      cachedResult = CBool(IsThemeActive) And (IsAppThemed)
    Else
      cachedResult = False
    End If
    isCached = True
  End If
  WinXp_IsThemed = cachedResult
End Function

Public Function WinXp_IsWinXP() As Boolean
  WinXp_IsWinXP = WinXp_GetOsVersionName$ = "XP" Or WinXp_GetOsVersionName$ = "Vista"
End Function

